<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class users {
	
	public $database;
	
	public function __construct() {
		$this->database = db::getInstance();
	}
	
	public function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__banner_users`");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		$this->database->setQuery("SELECT a.*, COUNT(user) AS count FROM `#__banner_users` AS a
		LEFT JOIN `#__banner` AS b ON a.id=b.user
		GROUP BY a.id
		$page_nav->sql_limit");
		$list = $this->database->loadObjectList();
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		if ($task == 'edit') {
			$this->database->setQuery("SELECT * FROM `#__banner_users` WHERE id='$id'");
			$object = $this->database->loadObject();
		}
		return $object;
	}
	
	public function save($method) {
		$id = AppleGetParam('id', $_GET, 0);
		$page = intval(AppleGetParam('page', $_POST, 1));
		$name = AppleGetParam('name', $_POST, null);
		$email = AppleGetParam('email', $_POST, null);
		
		$message = AppleMessage::getInstance();
		
		if ($name == null) {
			$message->add('error', __('Please enter user name.'));
			return false;
		}
		
		if ($method == 'edit') {
			$this->database->setQuery("UPDATE `#__banner_users` SET name='$name', email='$email' WHERE id='$id'");
			if ($this->database->query()) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			$this->database->setQuery("INSERT INTO `#__banner_users` (name, email) VALUES ('$name', '$email')");
			if ($this->database->query()) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete(){
		$page = intval(AppleGetParam('page', $_GET, 1));
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++){
			$this->database->setQuery("DELETE a.*, b.* FROM `#__banner_users` AS a
			LEFT JOIN `#__banner` AS b ON a.id=b.user
			WHERE a.id='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
}

class banners {
	
	public $database;
	
	public function __construct() {
		$this->database = db::getInstance();
	}
	
	public function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__banner` WHERE lng='".LANGUAGE."'");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		$this->database->setQuery("SELECT a.*, b.name AS user_name FROM `#__banner` AS a
		LEFT JOIN `#__banner_users` AS b ON a.user=b.id
		GROUP BY a.id
		ORDER BY ordering
		$page_nav->sql_limit");
		$list = $this->database->loadObjectList();
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		$this->database->setQuery("SELECT * FROM `#__banner_users`");
		$list = $this->database->loadObjectList();
		if (!empty($list)) {
			$users = array();
			foreach ($list as $k) {
				$users[] = AppleHTML::makeOption($k->id, $k->name);
			}
		}
		
		if ($method == 'edit') {
			$this->database->setQuery("SELECT * FROM `#__banner` WHERE id='$id'");
			$object = $this->database->loadObject();
		}
		else {
			$object = new stdClass();
		}
		$object->users = $users;
		return $object;
	}
	
	public function save($method) {
		$id = AppleGetParam('id', $_GET, 0);
		$page = intval(AppleGetParam('page', $_POST, 0));
		
		$obj = new stdClass();
		$obj->user = intval(AppleGetParam('user', $_POST, 0));
		$obj->name = AppleGetParam('name', $_POST, null);
		$obj->total = intval(AppleGetParam('total', $_POST, 0));
		$obj->view = intval(AppleGetParam('view', $_POST, 0));
		$obj->url = AppleGetParam('url', $_POST, null);
		$obj->image = AppleGetParam('image', $_POST, null);
		$obj->date = AppleConvertToGregorian(AppleGetParam('date', $_POST, null));
		$obj->start = AppleConvertToGregorian(AppleGetParam('start', $_POST, null));
		$obj->published = intval(AppleGetParam('published', $_POST, 0));
		$obj->lng = LANGUAGE;
		
		$message = AppleMessage::getInstance();
		
		if ($obj->name == null) {
			$message->add('error', __('Please enter banner name.'));
			return false;
		}
		if ($obj->url == null) {
			$message->add('error', __('Please enter banner url.'));
			return false;
		}
		if ($obj->image == null) {
			$message->add('error', __('Please enter banner image.'));
			return false;
		}
		
		if ($method == 'edit') {
			if ($this->database->update('`#__banner`', $obj, "id=$id")) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			if ($this->database->insert('`#__banner`', $obj)) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete() {
		$page = intval(AppleGetParam('page', $_GET, 1));
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++) {
			$this->database->setQuery("DELETE FROM `#__banner` WHERE `id`='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function publish($p){
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		for ($i=0; $i<count($id); $i++) {
			$this->database->SetQuery("UPDATE `#__banner` SET `published`='$p' WHERE `id`='$id[$i]'");
		}
		$message = AppleMessage::getInstance();
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		$message->add('error', __('unknown_error'));
		return false;
	}
	
	public function reOrder() {
		$message = AppleMessage::getInstance();
		if (AppleAjaxRequest()) {
			$sort = AppleGetParam('sort', $_POST);
			if ($sort == null) {
				$message->add('success', __('Changes updated successfully'));
				echo AppleShowMessage();
				return true;
			}
			
			$count = count(explode('&', $sort));
			
			parse_str($sort);
			
			$ab = array();
			$a = $tb_list;
			sort($a);
			
			$p=0;
			for ($i=0; $i<$count; $i++) {
				$ab[$tb_list[$i]['id']] = $a[$p++]['id'];
			}
			foreach ($ab as $k=>$v) {
				$this->database->setQuery("UPDATE `#__banner` SET `ordering`=$v WHERE id=$k");
				if (!$this->database->query()) {
					$message->add('error', __('Queries are done with error'));
					echo AppleShowMessage();
					return false;
				}
			}
			$message->add('success', __('Changes updated successfully'));
			echo AppleShowMessage();
			return true;
		}
		else {
			$id = AppleGetParam('id', $_GET);
			$do = AppleGetParam('do', $_GET, 'up');
			
			$this->database->sort('`#__banner`', $id, ''.$do.'');
		}
	}
}
?>