<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class usersHTML {
	function view($list, $page_nav) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		AppleSetPath(__('Users Management'));
		?>
		<form action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		$action[] = AppleHTML::makeOption('new', __('New'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		
		$table = new table(null, null, 'width:700px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'action', 'id="action"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'action\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'action\').value != \'\' && $(\'action\').value != \'delete\')) submitButton(this.form, $(\'action\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:800px;');
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('<input type="checkbox" onClick="checkAll(this);">', 'width:5px;');
		$table->addTH(__('Name'), 'width:350px;');
		$table->addTH(__('E-Mail'), 'width:300px;');
		$table->addTH(__('Count Of Banners'), 'width:80px;');
		$table->addTH(__('Edit'), 'width:30px;');
		$table->addTH(__('Delete'), 'width:30px;');
		
		@reset($list);
		$i = 0;
		$p = ($page-1)*$page_nav->limit_length;
		if (!empty($list)) {
			foreach ($list as $item) {
				$i++;
				$table->addTR("id=\"tr_$item->id\"");
				$table->addTD(++$p);
				$table->addTD('<input type="checkbox" id="'.$item->id.'">');
				$table->addTD('<a href="?com=banner&section=users&task=edit&id='.$item->id.'&lng='.LANGUAGE.'">'.$item->name.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				$table->addTD($item->email, 'text-align:left;');
				$table->addTD($item->count);
				$table->addTD(AppleHTML::editIcon($item->id));
				$table->addTD(AppleHTML::deleteIcon($item->id, 'list'));
			}
		}
		
		$table->show();
		?>
		<input type="hidden" name="com" value="banner" />
		<input type="hidden" name="section" value="users" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="" />
		<input type="hidden" name="page" value="<?php echo $page; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
		echo $page_nav->writePages();
	}
	
	function form($method, $object=null) {
		$id = intval(AppleGetParam('id', $_GET, 0));
		$page = intval(AppleGetParam('page', $_GET, 1));
		if ($method == 'new') AppleSetPath(__('New User'));
		else AppleSetPath(__('Edit User'));
		?>
		<form action="?com=banner&section=users&task=<?php echo $method; ?>&id=<?php echo $id; ?>&lng=<?php echo LANGUAGE; ?>" method="POST">
		<table width="100%" border="0">
		<tr>
		<td valign="top" width="40%">
		<table border="0">
		<tr>
		<td><?php _e('Name'); ?> :</td><td><?php echo AppleHTML::makeText('name', $object->name); ?></td>
		</tr>
		<tr>
		<td><?php _e('E-mail'); ?> :</td><td><?php echo AppleHTML::makeText('email', $object->email, 'dir="ltr"'); ?></td>
		</tr>
		<tr><td colspan="2">
		
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=banner&section=users&page='.$page.'&lng='.LANGUAGE.'\'"'); ?>
		</td></tr>
		</table>
		</td>
		</tr>
		</table>
		</form>
		<?php
	}
}

class bannersHTML {
	function view($list, $page_nav) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		AppleSetPath(__('Banners Management'));
		?>
		<form action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		$action[] = AppleHTML::makeOption('new', __('New'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		$action[] = AppleHTML::makeOption('publish', __('Publish'));
		$action[] = AppleHTML::makeOption('unpublish', __('Unpublish'));
		
		$table = new table(null, null, 'width:800px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'action', 'id="action"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'action\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'action\').value != \'\' && $(\'action\').value != \'delete\')) submitButton(this.form, $(\'action\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:920px;');
		$table->sortable = true;
		$table->sort_url = '?com=banner&task=reorder';
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('<input type="checkbox" onClick="checkAll(this);">', 'width:5px;');
		$table->addTH(__('Name'), 'width:340px;');
		$table->addTH(__('User Name'), 'width:200px;');
		$table->addTH(__('Count Of View'), 'width:70px;');
		$table->addTH(__('Count Of Remains'), 'width:70px;');
		$table->addTH(__('Count Of Click'), 'width:70px;');
		$table->addTH(__('Publish'), 'width:50px;');
		$table->addTH(__('Reorder'), 'width:50px;', 'colspan="2"');
		$table->addTH(__('Edit'), 'width:30px;');
		$table->addTH(__('Delete'), 'width:30px;');
		
		@reset($list);
		$i = 0;
		$p = ($page-1)*$page_nav->limit_length;
		if (!empty($list)) {
			foreach ($list as $item) {
				$i++;
				$table->addTR("id=\"tr_$item->id\"");
				$table->addTD(++$p);
				$table->addTD('<input type="checkbox" id="'.$item->id.'">');
				$name = null;
				for ($j=0; $j<$item->level; $j++) $name .= '&nbsp;&nbsp;.&nbsp;&nbsp;';
				$table->addTD('<a href="?com=banner&task=edit&id='.$item->id.'&page='.$page.'&lng='.LANGUAGE.'">'.$item->name.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				$table->addTD('<a href="?com=banner&section=users&task=edit&id='.$item->user.'&page='.$page.'&lng='.LANGUAGE.'">'.$item->user_name.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				
				$table->addTD($item->view);
				$table->addTD($item->total == 0 ? __('Unlimit') : $item->total-$item->view);
				$table->addTD($item->clicks);
				$table->addTD(AppleHTML::publishIcon($item->id, $item->published));
				//$table->addTD(AppleHTML::moveUpIcon($item->id, $list[$i-2] != null));
				//$table->addTD(AppleHTML::moveDownIcon($item->id, $list[$i] != null));
				$table->addTD('<img src="images/move.gif" />', null, 'colspan=2');
				$table->addTD(AppleHTML::editIcon($item->id));
				$table->addTD(AppleHTML::deleteIcon($item->id, 'list'));
			}
		}
		
		$table->show();
		?>
		<input type="hidden" name="com" value="banner" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="" />
		<input type="hidden" name="page" value="<?php echo $page; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
		echo $page_nav->writePages();
	}
	
	function form($method, $object=null) {
		$id = intval(AppleGetParam('id', $_GET, 0));
		$page = intval(AppleGetParam('page', $_GET, 1));
		
		if ($method == 'new') AppleSetPath(__('New Banner'));
		else AppleSetPath(__('Edit Banner'));
		?>
		<form action="?com=banner&task=<?php echo $method; ?>&id=<?php echo $id; ?>&lng=<?php echo LANGUAGE; ?>" method="POST">
		<table width="100%" border="0">
		<tr>
		<td valign="top" width="40%">
		<table border="0">
		<tr>
		<td><?php _e('Name'); ?> : </td><td><input type="text" class="input" name="name" value="<?php echo $object->name; ?>"></td>
		</tr>
		<tr>
		<td><?php _e('User Name'); ?> : </td><td><?php echo AppleHTML::makeList($object->users, 'user', null, $object->user); ?></td>
		</tr>
		<tr>
		<td><?php _e('url'); ?> : </td><td><input type="text" class="input" name="url" value="<?php echo $object->url; ?>" dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('Image Address'); ?> : </td><td><input type="text" class="input" name="image" value="<?php echo $object->image; ?>" dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('Total View'); ?> : </td><td><input type="text" class="input" name="total" value="<?php echo $object->total; ?>" dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('View'); ?> : </td><td><input type="text" class="input" name="view" value="<?php echo $object->view; ?>" dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('Date'); ?> : </td><td><input type="text" class="input" name="date" value="<?php echo $object->date!=null ? AppleDate($object->date, 'Y-m-d H:i:s', 0, 0, 'g') : AppleDate(null, 'Y-m-d H:i:s', 0, 0); ?>" dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('Start Publishing'); ?> : </td><td><input type="text" class="input" name="start" value="<?php echo $object->start!=null ? AppleDate($object->start, 'Y-m-d H:i:s', 0, 0, 'g') : AppleDate(null, 'Y-m-d H:i:s', 0, 0); ?>" dir="ltr"></td>
		</tr>
		
		<?php
		$pub = array();
		$pub[] = AppleHTML::makeOption('0', __('Unpublish'));
		$pub[] = AppleHTML::makeOption('1', __('Publish'));
		?>
		<tr>
		<td><?php _e('Publish Status'); ?> : </td>
		<td><?php echo AppleHTML::makeList($pub, 'published', 'id="published"', ($object->published || $method == 'new')); ?></td>
		</tr>
		<tr><td colspan="2">
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=banner&page='.$page.'&lng='.LANGUAGE.'\'"'); ?>
		</td></tr>
		</table>
		</td>
		</tr>
		</table>
		</form>
		<?php
	}
}
?>