<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class adminCategory {
	public $database;
	public $_404 = false;
	
	public function __construct($parts, $id) {
		$this->database = db::getInstance();
		
		if ($id == 0 && AppleIsSef() && $parts[1] == 'cat') {
			$_GET['section'] = 'category';
			$this->database->setQuery("SELECT * FROM `#__categories` WHERE `unique_name`='$parts[2]' AND lng='".LANGUAGE."'");
			$obj = $this->database->loadObject();
			if ($obj == null) $this->_404 = true;
			else $_GET['id'] = $obj->id;
		}
	}
	
	function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__categories` WHERE lng='".LANGUAGE."'");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		
		$start = ($page_nav->page-1)*$page_nav->limit;
		$list = AppleMakeTree('#__categories', 0, "lng='".LANGUAGE."'", true, $start, $page_nav->limit);
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		if ($task == 'edit') {
			$this->database->setQuery("SELECT * FROM `#__categories` WHERE id='$id'");
			$object = $this->database->loadObject();
		}
		return $object;
	}
	
	public function save($method) {
		$id = AppleGetParam('id', $_GET, 0);
		$name = AppleGetParam('name', $_POST, null);
		$parent = AppleGetParam('parent', $_POST, 0);
		$published = intval(AppleGetParam('published', $_POST, 0));
		$title = AppleGetParam('menu_title', $_POST, null);
		$menu = intval(AppleGetParam('menu_name', $_POST, 0));
		$lng = LANGUAGE;
		$url = '?com=content&section=categories&id='.$id.'&lng='.$lng;
		
		$message = AppleMessage::getInstance();
		
		if ($name == null) {
			$message->add('error', __('Enter category name'));
			return false;
		}
		
		if ($method == 'edit') {
			$this->database->setQuery("UPDATE `#__categories` SET name='$name', parent='$parent', published='$published' WHERE id='$id'");
			if ($title != null) $this->database->setQuery("INSERT INTO `#__menu_items` (menu, internal, ispage, title, url) VALUES ('$menu', '1', '1', '$title', '$url')");
			if ($this->database->query()) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			$this->database->setQuery("INSERT INTO `#__categories` (name, parent, published, lng) VALUES ('$name', '$parent', '$published', '$lng')");
			if ($this->database->query()) {
				if ($title != null) {
					$id = $this->database->insertId();
					$url = '?com=content&section=categories&id='.$id.'&lng='.$lng;
					$this->database->setQuery("INSERT INTO `#__menu_items` (menu, url, title, internal, ispage) VALUES ('$menu', '$url', '$title', '1', '1')");
					if ($this->database->query()) {
						$message->add('success', __('Changes updated successfully'));
						return true;
					}
					else {
						$message->add('error', __('unknown_error'));
						return false;
					}
				}
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete() {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++) {
			if ($this->getContentNumbers($id[$i]) > 0 || $this->getChildrenNumbers($id[$i]) > 0) {
				$message->add('error', __('Category is not empty'));
				return false;
			}
			$this->database->setQuery("DELETE FROM `#__categories` WHERE `id`='$id[$i]'");
			$this->database->setQuery("DELETE FROM `#__menu_items` WHERE `internal`='1' AND `url` LIKE '%com=content%section=categories%id=$id[$i]%'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function publish($p) {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		for ($i=0; $i<count($id); $i++) {
			$this->database->SetQuery("UPDATE `#__categories` SET `published`='$p' WHERE `id`='$id[$i]'");
		}
		if ($this->database->query())
			return true;
		$message = AppleMessage::getInstance();
		$message->add('error', __('unknown_error'));
		AppleGoBack();
	}
	
	public function getName($id) {
		global $database;
		$database->setQuery("SELECT name FROM `#__categories` WHERE id='$id'");
		$category = $database->loadObject();
		return ($category->name != null) ? $category->name : '-';
	}
	
	public function getContentNumbers($id) {
		global $database;
		$database->setQuery("SELECT COUNT(*) AS num FROM `#__content` WHERE cid='$id'");
		$obj = $database->loadObject();
		return $obj->num;
	}
	
	public function getChildrenNumbers($id) {
		global $database;
		$database->setQuery("SELECT COUNT(*) AS num FROM `#__categories` WHERE parent='$id'");
		$obj = $database->loadObject();
		return $obj->num;
	}
	
	public function createdLinks($id) {
		global $database;
		if ($id == 0) return null;
		$database->setQuery("SELECT * FROM `#__menu_items` WHERE internal='1' AND ispage=1 AND `url` LIKE '%com=content%section=categories%id=$id%' ORDER BY menu");
		$list = $database->loadObjectList();
		return $list;
	}
	
	public function menu($msg=null) {
		$method = AppleGetParam('method', $_GET, 'new');
		$id = intval(AppleGetParam('id', $_GET, 0));
		categoryHTML::menuStatus($method, $id, $msg);
	}
	
	public function getMenuList() {
		global $database;
		$database->setQuery("SELECT * FROM `#__menu` WHERE `lng`='".LANGUAGE."' ORDER BY id");
		$list = $database->loadObjectList();
		return $list;
	}
	
	public function addMenu() {
		$title = AppleGetParam('title', $_POST, null);
		$menu = intval(AppleGetParam('menu', $_POST, 0));
		$id = intval(AppleGetParam('id', $_GET, 0));
		$lng = LANGUAGE;
		$url = '?com=content&section=categories&id='.$id.'&lng='.$lng;
		if ($title == null) {
			$msg = AppleShowMessage(__('Enter menu title'), 1);
		}
		else {
			global $database;
			$database->setQuery("INSERT INTO `#__menu_items` (menu, url, title, internal, ispage) VALUES ('$menu', '$url', '$title', '1', '1')");
			if (!$database->query()) $msg = AppleShowMessage(__('unknown_error'), 1);
			else $msg = null;
		}
		$this->menu($msg);
		exit();
	}
	
	public function reOrder() {
		$message = AppleMessage::getInstance();
		if (AppleAjaxRequest()) {
			$level = AppleGetParam('level', $_POST);
			$sort = AppleGetParam('sort', $_POST);
			if ($level == null || $sort == null) {
				$message->add('success', __('Changes updated successfully'));
				echo AppleShowMessage();
				return true;
			}
			
			$count = count(explode('&', $level));
			
			parse_str($level);
			parse_str($sort);
			
			$ab = array();
			
			foreach ($level as $k=>$a) {
				sort($a);
				$p = 0;
				for ($i=0; $i<$count; $i++) {
					if (in_array($tb_list[$i]['id'], $a)) {
						$ab[$tb_list[$i]['id']] = $a[$p++];
					}
				}
			}
			
			foreach ($ab as $k=>$v) {
				$this->database->setQuery("UPDATE `#__categories` SET `ordering`=$v WHERE id=$k");
				if (!$this->database->query()) {
					$message->add('error', __('Queries are done with error'));
					echo AppleShowMessage();
					return false;
				}
			}
			$message->add('success', __('Changes updated successfully'));
			echo AppleShowMessage();
			return true;
		}
		else {
			$id = AppleGetParam('id', $_GET);
			$do = AppleGetParam('do', $_GET, 'up');
			
			$this->database->sort('`#__categories`', $id, ''.$do.'', 'parent,lng');
			AppleGoBack();
		}
	}
}

class adminContent {
	public $database;
	public $message;
	public $_404 = false;
	
	public function __construct($parts, $id) {
		$this->database = db::getInstance();
		$this->message = AppleMessage::getInstance();
		
		if ($id == 0 && AppleIsSef() && $parts[0] != 'content') {
			$_GET['section'] = 'content';
			$this->database->setQuery("SELECT * FROM `#__content` WHERE `unique_name`='$parts[0]' AND lng='".LANGUAGE."'");
			$obj = $this->database->loadObject();
			if ($obj == null) $this->_404 = true;
			else $_GET['id'] = $obj->id;
		}
	}
	
	public function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__content` WHERE lng='".LANGUAGE."'");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		$this->database->setQuery("SELECT * FROM `#__content` WHERE lng='".LANGUAGE."' ORDER BY `ordering` $page_nav->sql_limit");
		$list = $this->database->loadObjectList();
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		if ($_POST) {
			$object = new stdClass();
			$object->id = AppleGetParam('id', $_GET, 0);
			$object->page = intval(AppleGetParam('page', $_POST, 1));
			$object->title = AppleGetParam('title', $_POST, null);
			$object->unique_name = AppleGetParam('unique_name', $_POST, null);
			$object->text = AppleGetParam('text', $_POST, null, _MOS_ALLOWHTML);
			$object->published = intval(AppleGetParam('published', $_POST, 0));
			$object->date = AppleConvertToGregorian(AppleGetParam('date', $_POST, null));
			$object->start = AppleConvertToGregorian(AppleGetParam('start', $_POST, null));
			$object->end = AppleConvertToGregorian(AppleGetParam('end', $_POST, '0000-00-00 00:00:00'));
			$object->keywords = AppleGetParam('keywords', $_POST, null);
			$object->cid = AppleGetParam('cid', $_POST, 0);
			$object->date_status = AppleGetParam('date_status', $_POST, 0);
			$object->print_status = AppleGetParam('print_status', $_POST, 0);
		}
		elseif ($task == 'edit') {
			$this->database->setQuery("SELECT a.*, b.name AS author, c.name AS modified_by FROM `#__content` AS a
			INNER JOIN `#__users` AS b ON a.author = b.id
			LEFT JOIN `#__users` AS c ON a.modified_by = c.id
			WHERE a.id='$id'");
			$object = $this->database->loadObject();
		}
		return $object;
	}
	
	public function save($method) {
		$id = AppleGetParam('id', $_GET, 0);
		$title = AppleGetParam('title', $_POST, null);
		$unique_name = AppleGetParam('unique_name', $_POST, null);
		$text = AppleGetParam('text', $_POST, null, _MOS_ALLOWHTML);
		$published = intval(AppleGetParam('published', $_POST, 0));
		$date = AppleConvertToGregorian(AppleGetParam('date', $_POST, null));
		$start = AppleConvertToGregorian(AppleGetParam('start', $_POST, null));
		$end = AppleConvertToGregorian(AppleGetParam('end', $_POST, '0000-00-00 00:00:00'));
		$keywords = AppleGetParam('keywords', $_POST, null);
		$cid = AppleGetParam('cid', $_POST, 0);
		$date_status = AppleGetParam('date_status', $_POST, 0);
		$print_status = AppleGetParam('print_status', $_POST, 0);
		
		if ($title == null) $this->message->add('error', __('Enter content title'));
		if ($text == null) $this->message->add('error', __('Enter content text'));
		if ($unique_name != null) {
			
			if (eregi("[^0-9A-z_\-]", $unique_name)) {
				 $this->message->add('error', __('Your post name only can be contains character or digit or dash or underline. Please try another name.'));
			}
			else {
				$this->database->setQuery("SELECT `name` FROM `#__components`
				WHERE `name`='$unique_name'");
				$ob = $this->database->loadObject();
				if ($ob != null) $this->message->add('error', sprintf(__('You have installed one component with "%s" name. Please try another name.'), $unique_name));
				else {
					$this->database->setQuery("SELECT `unique_name` FROM `#__content`
					WHERE `unique_name`='$unique_name' AND `id`!=$id AND lng='".LANGUAGE."'");
					$ob = $this->database->loadObject();
					if ($ob != null) $this->message->add('error', sprintf(__('You have one post with "%s" name. Please try another name.'), $unique_name));
				}
			}
		}
		
		if (!$this->message->isNull()) return false;
		
		$menu_title = AppleGetParam('menu_title', $_POST, null);
		$menu = intval(AppleGetParam('menu_name', $_POST, 0));
		$lng = LANGUAGE;
		$url = '?com=content&id='.$id.'&lng='.$lng;
		
		$user = AppleUser::getInstance();
		$author = $user->id;
		$now = AppleGetNow('Y-m-d H:i:s');
		
		if ($method == 'edit') {
			$this->database->setQuery("UPDATE `#__content` SET 
			cid='$cid', title='$title', unique_name='$unique_name', keywords='$keywords', text='$text', date='$date', start='$start', end='$end', modified='$now', modified_by='$author', date_status='$date_status', print_status='$print_status', published='$published', lng='$lng' WHERE id='$id'");
			if ($menu_title != null) $this->database->setQuery("INSERT INTO `#__menu_items` (menu, url, title, internal, ispage) VALUES ('$menu', '$url', '$menu_title', '1', '1')");
			if ($this->database->query()) {
				$this->message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$this->message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			$this->database->setQuery("INSERT INTO `#__content` (cid, author, title, unique_name, keywords, text, date, start, end, date_status, print_status, email_status, published, lng) 
			VALUES ('$cid', '$author', '$title', '$unique_name', '$keywords', '$text', '$date', '$start', '$end', '$date_status', '$print_status', '0', '$published', '$lng')");
			if ($this->database->query()) {
				if ($menu_title != null) {
					$id = $this->database->insertId();
					$url = '?com=content&id='.$id.'&lng='.$lng;
					$this->database->setQuery("INSERT INTO `#__menu_items` (menu, url, title, internal, ispage) VALUES ('$menu', '$url', '$menu_title', '1', '1')");
					if ($this->database->query()) {
						$this->message->add('success', __('Changes updated successfully'));
						return true;
					}
					else {
						$this->message->add('error', __('Link not cteated'));
						return false;
					}
				}
				$this->message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$this->message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete() {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);	
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++){
			$this->database->setQuery("DELETE FROM `#__content` WHERE `id`='$id[$i]'");
			$this->database->setQuery("DELETE FROM `#__menu_items` WHERE `internal`='1' AND `url` LIKE '%com=content&id=$id[$i]%'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
			
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function publish($p) {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		
		for ($i=0; $i<count($id); $i++){
			$this->database->SetQuery("UPDATE `#__content` SET `published`='$p' WHERE `id`='$id[$i]'");
		}
		if ($this->database->query())
			return true;
		else
			$this->message->add('error', __('unknown_error'));
			return false;
	}
	
	static function getCategory($id) {
		global $database;
		$database->setQuery("SELECT name FROM `#__categories` WHERE id='$id'");
		$category = $database->loadObject();
		return ($category->name != null) ? $category->name : '-';
	}
	
	
	
	public function menu() {
		$do = 'menu_'.AppleGetParam('do', $_GET, 'new');
		$id = intval(AppleGetParam('od', $_GET, 0));
		self::$do($id);
	}
	
	public function menu_new() {
		$title = AppleGetParam('title', $_POST, null);
		$menu = intval(AppleGetParam('menu', $_POST, 0));
		$id = intval(AppleGetParam('id', $_GET, 0));
		$lng = LANGUAGE;
		$url = '?com=content&id='.$id.'&lng='.$lng;
		if ($title == null) {
			$msg = __('Enter menu title');
		}
		else {
			global $database;
			
			$database->setQuery("INSERT INTO `#__menu_items` (menu, url, title, internal, ispage) VALUES ('$menu', '$url', '$title', '1', '1')");
			if (!$database->query()) $msg = __('unknown_error');
			else $msg = '';
		}
		
		self::menu_createdLinks($id);
		if ($msg != null) echo '<script type="text/javascript">
		alert("'.addslashes($msg).'");
		$("menu_title").value = "";
		</script>';
		else echo '<script type="text/javascript">
		new AppleOpenCloseDiv("menu_created", "menu_form");
		</script>';
	}
	
	public function menu_delete($id) {
		global $database;
		//$menu = intval(AppleGetParam('menu', $_GET, 0));
		if ($id == 0) return;
		
		$database->setQuery("DELETE FROM `#__menu_items` WHERE id='$id'");
		if ($database->query()) {
			echo '<script type="text/javascript">
			$("menu_'.$id.'").style.display = "none";
			if ($("count_menu").value-1 == 0) $("menu_createdLinks").style.display = "none";
			</script>';
		}
	}
	
	public function menu_createdLinks($id) {
		global $database;
		if ($id == 0) return null;
		
		$database->setQuery("SELECT * FROM `#__menu_items` WHERE internal='1' AND ispage='1' AND `url` LIKE '%com=content&id=$id%' ORDER BY menu, ordering");
		$list = $database->loadObjectList();
		HTML::menu_createdLinks($list);
	}
	
	public function getMenuList() {
		global $database;
		$database->setQuery("SELECT * FROM `#__menu` WHERE `lng`='".LANGUAGE."' ORDER BY id");
		$list = $database->loadObjectList();
		return $list;
	}
	
	public function reOrder() {
		$message = AppleMessage::getInstance();
		if (AppleAjaxRequest()) {
			$sort = AppleGetParam('sort', $_POST);
			if ($sort == null) {
				$message->add('success', __('Changes updated successfully'));
				echo AppleShowMessage();
				return true;
			}
			
			$count = count(explode('&', $sort));
			
			parse_str($sort);
			
			$ab = array();
			$a = $tb_list;
			sort($a);
			
			$p=0;
			for ($i=0; $i<$count; $i++) {
				$ab[$tb_list[$i]['id']] = $a[$p++]['id'];
			}
			foreach ($ab as $k=>$v) {
				$this->database->setQuery("UPDATE `#__content` SET `ordering`=$v WHERE id=$k");
				if (!$this->database->query()) {
					$message->add('error', __('Queries are done with error'));
					echo AppleShowMessage();
					return false;
				}
			}
			$message->add('success', __('Changes updated successfully'));
			echo AppleShowMessage();
			return true;
		}
		else {
			$id = AppleGetParam('id', $_GET);
			$do = AppleGetParam('do', $_GET, 'up');
			
			$this->database->sort('`#__content`', $id, ''.$do.'', 'cid,lng');
			AppleGoBack();
		}
	}
}
?>
