<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class manageLanguage {
	public $database;
	
	public function __construct() {
		$this->database = db::getInstance();
	}
	
	public function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__languages`");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		$this->database->setQuery("SELECT * FROM `#__languages` $page_nav->sql_limit");
		$list = $this->database->loadObjectList();
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		if ($task == 'edit' && $id != null) {
			$this->database->setQuery("SELECT * FROM `#__languages` WHERE lng='$id'");
			$object = $this->database->loadObject();
		}
		return $object;
	}
	
	public function save($method) {
		$id = AppleGetParam('id', $_GET, null);
		$name = AppleGetParam('name', $_POST, null);
		$lng = AppleGetParam('lng', $_POST, null);
		$old_lng = AppleGetParam('old_lng', $_POST, null);
		
		$message = AppleMessage::getInstance();
		
		if ($lng == null || eregi("[^A-z_]", $lng)) {
			$message->add('error', __('Please enter language short name.'));
			return false;
		}
		
		if ($name == null) {
			$message->add('error', __('Please enter language name.'));
			return false;
		}
		
		if ($method == 'edit') {
			$this->database->setQuery("SELECT * FROM `#__languages` WHERE `lng`='$lng' AND `name` != '$name'");
			if ($this->database->loadObject() != null) {
				$message->add('error', sprintf(__('You can not take %s for your new language. this was token before.'), $lng));
				return false;
			}
			$this->database->setQuery("UPDATE `#__languages` SET name='$name', lng='$lng' WHERE lng='$id'");
			$this->database->setQuery("UPDATE `#__theme` SET lng='$lng' WHERE lng='$id'");
			$this->database->setQuery("UPDATE `#__settings` SET lng='$lng' WHERE lng='$id'");
			if ($this->database->query()) {
				$message->add('success', __('Changes updated successfully'));
				rename(settings::get('root_path').'/languages/'.$old_lng, settings::get('root_path').'/languages/'.$lng);
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			$this->database->setQuery("SELECT * FROM `#__languages` WHERE `lng`='$lng'");
			if ($this->database->loadObject() != null) {
				$message->add('error', sprintf(__('You can not take %s for your new language. this was token before.'), $lng));
				return false;
			}
			$this->database->setQuery("SELECT * FROM `#__settings` WHERE `lng`='".DEFAULT_LANGUAGE."'");
			$list = $this->database->loadObjectList();
			foreach ((array)$list as $k) {
				$k->lng = $lng;
			}
			reset($list);
			$this->database->setQuery("INSERT INTO `#__languages` (lng, name) VALUES ('$lng', '$name')");
			$this->database->setQuery("INSERT INTO `#__theme` (`theme`, `menu`, `lng` ) VALUES ('Apple', '0', '$lng')");
			if ($this->database->query()) {
				foreach ($list as $k) {
					$this->database->insert('`#__settings`', $k);
				}
				$fm = new AppleFileManager(settings::get('root_path').'/languages');
				$fm->copy(settings::get('root_path').'/languages/'.DEFAULT_LANGUAGE, settings::get('root_path').'/languages/'.$lng);
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete() {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		
		$message = AppleMessage::getInstance();
		
		if ($count == 1 && $id[0] == DEFAULT_LANGUAGE) {
			$message->add('error', __('You can not delete default language.'));
			return false;
		}
		
		$fm = new AppleFileManager(settings::get('root_path').'/languages');
		
		for ($i=0; $i<$count; $i++) {
			if ($id[$i] == DEFAULT_LANGUAGE) continue;
			$this->database->setQuery("DELETE FROM `#__languages` WHERE `lng`='$id[$i]'");
			$this->database->setQuery("DELETE FROM `#__theme` WHERE `lng`='$id[$i]'");
			$this->database->setQuery("DELETE FROM `#__settings` WHERE `lng`='$id[$i]'");
			$fm->file = $id[$i];
			$fm->delete();
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function files($lng) {
		$path = Apple_root_path.'/languages/'.$lng;
		$dir = @dir($path);
		$list = array();
		
		while (($file = $dir->read()) != null) {
			if (is_file($path.'/'.$file) && $file != 'index.html') $list[] = $file;
		}
		
		return $list;
	}
	
	public function translate() {
		$message = AppleMessage::getInstance();
		
		$catalog = new appleGetText();
		$catalog->path = Apple_root_path.'/languages/'.AppleGetParam('id', $_GET, null);
		$catalog->file = AppleGetParam('file', $_GET, null);
		if (!file_exists($catalog->path.'/'.$catalog->file.'.po')) {
			$message->add('error', sprintf(__('File %s doesn\'t exist!'), '"'.$catalog->file.'.po"'));
			return false;
		}
		if (!is_writable($catalog->path.'/'.$catalog->file.'.po')) {
			$message->add('error', sprintf(__('File %s is not writable!'), '"'.$catalog->file.'.po"'));
			return false;
		}
		if (!is_writable($catalog->path.'/LC_MESSAGES/'.$catalog->file.'.mo')) {
			$message->add('error', sprintf(__('File %s is not writable!'), '"'.$catalog->file.'.mo"'));
			return false;
		}
		$catalog->readPO();
		
		$catalog->setComments($_POST['comments']);
		$catalog->setHeaders($_POST['headers']);
		
		foreach ($_POST as $key => $value) {
			if (preg_match('/^([a-z]+[_]?[a-z]+?)[_]?([0-9]+)?_([0-9]+)$/', $key, $matches)) {
				switch ($matches[1]) {
					case 'msgid':
						if (get_magic_quotes_gpc() == 1) {
							$value = stripslashes($value);
						}
						$messages[$matches[3]]['msgid'] = $value;
						break;
					case 'msgid_plural':
						$messages[$matches[3]]['msgid_plural'] = $value;
						break;
					case 'msgstr':
						if (!empty($messages[$matches[3]]['msgid_plural'])) {
							if ($matches[2] != '') {
								$messages[$matches[3]]['msgstr'][$matches[2]] =  stripslashes($value);
							} else {
								$messages[$matches[3]]['msgstr'][0] =  stripslashes($value);
								$messages[$matches[3]]['msgstr'][1] =  '';
							}
						} else {
							$messages[$matches[3]]['msgstr'] =  stripslashes($value);
						}
						break;
					case 'fuzzy':
						$messages[$matches[3]]['fuzzy'] = $value == 'true' ? true : false;
						break;
				}
			}
		}
		
		foreach ($messages as $index => $arr) {
			if (strcmp($catalog->strings[$index]->msgid, $arr['msgid']) == 0) {
				$catalog->strings[$index]->setmsgstr($arr['msgstr']);
				$catalog->strings[$index]->setfuzzy($arr['fuzzy']);
			}
		}
		
		$catalog->writePO();
		
		require_once(Apple_root_path.'/kernel/File_Gettext/Gettext.php');
		$po = $catalog->path.'/'.$catalog->file.'.po';
		$mo = $catalog->path.'/LC_MESSAGES/'.$catalog->file.'.mo';
		
		$x = new File_Gettext();
		if ($x->poFile2moFile($po, $mo)) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		else {
			$message->add('error', __('unknown_error'));
			return false;
		}
	}
}
?>