<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class languagesHTML {
	public function view($list, $page_nav) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		AppleSetPath(__('Language Management'));
		?>
		<form action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		$action[] = AppleHTML::makeOption('new', __('New'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		
		$table = new table(null, null, 'width:700px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'action', 'id="action"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'action\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'action\').value != \'\' && $(\'action\').value != \'delete\')) submitButton(this.form, $(\'action\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:550px;');
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('<input type="checkbox" onClick="checkAll(this);">', 'width:5px;');
		$table->addTH(__('Name'), 'width:300px;');
		$table->addTH(__('Manage Translates'), 'width:150px;');
		$table->addTH(__('Edit'), 'width:30px;');
		$table->addTH(__('Delete'), 'width:30px;');
		
		@reset($list);
		$p = ($page-1)*$page_nav->limit_length;
		if (!empty($list)) {
			foreach ($list as $item) {
				$i++;
				$table->addTR("id=\"tr_$item->id\"");
				$table->addTD(++$p);
				$table->addTD('<input type="checkbox" id="'.$item->lng.'">');
				$table->addTD('<a href="?com=languages&task=edit&id='.$item->lng.'&page='.$page.'&lng='.LANGUAGE.'">'.$item->name.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				$table->addTD('<a href="?com=languages&task=translate&id='.$item->lng.'&lng='.LANGUAGE.'">'.__('Manage Translates').'</a>');
				$table->addTD(AppleHTML::editIcon($item->lng));
				$table->addTD(AppleHTML::deleteIcon($item->lng));
			}
		}
		
		$table->show();
		?>
		<input type="hidden" name="com" value="languages" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="" />
		<input type="hidden" name="page" value="<?php echo $page; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
		echo $page_nav->writePages();
	}
	
	public function form($method, $object=null) {
		$id = AppleGetParam('id', $_GET, null);
		$page = intval(AppleGetParam('page', $_GET, 1));
		if ($method == 'new') AppleSetPath(__('New Language'));
		else AppleSetPath(__('Edit Language'));
		?>
		<form action="?com=languages&task=<?php echo $method; ?>&id=<?php echo $id; ?>&lng=<?php echo LANGUAGE; ?>" method="POST">
		<table width="100%" border="0">
		<tr>
		<td valign="top" width="40%">
		<table border="0">
		<tr>
		<td><?php _e('Short Name'); ?> :</td><td><?php echo AppleHTML::makeHiddenText('old_lng', $object->lng, 'type= "hidden" dir="ltr"'); echo AppleHTML::makeText('lng', $object->lng, 'dir="ltr"'); ?></td>
		</tr>
		<tr>
		<td><?php _e('Name'); ?> :</td><td><?php echo AppleHTML::makeText('name', $object->name); ?></td>
		</tr>
		<tr><td colspan="2">
		
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=languages&page='.$page.'&lng='.LANGUAGE.'\'"'); ?>
		</td></tr>
		</table>
		</td>
		</tr>
		</table>
		</form>
		<?php
	}
	
	public function files($list, $id) {
		AppleSetPath(__('Manage Translates'));
		$table = new table('list', null, 'width:400px;');
		$table->addTR();
		$table->addTH(__('File Name'), 'text-align:'.(settings::get('direction')=='ltr'?'left':'right').';');
		$table->addTH(__('Edit'), 'width:30px;');
		foreach ($list as $f) {
			$f = str_replace('.po', '', $f);
			$table->addTR();
			$table->addTD($f, 'text-align:'.(settings::get('direction')=='ltr'?'left':'right').';');
			$table->addTD('<a href="?com=languages&task=translate&file='.$f.'&id='.$id.'&lng='.LANGUAGE.'">'.__('Edit').'</a>');
		}	
		$table->show();
	}
	
	public function translate($file, $path) {
		$id = AppleGetParam('id', $_GET, null);
		AppleSetPath(__('Manage Translates'));
		$catalog = new AppleGetText();
		$catalog->path = $path;
		$catalog->file = $file;
		$catalog->readPO();
		
		
		echo '<script type="text/javascript" src="components/languages/index.js"></script>
		<form action="?com=languages&task=translate&file='.$file.'&id='.$id.'&lng='.LANGUAGE.'" method="POST">
		<div style="width:100%;height:200px;overflow:auto;">';
		$table = new table('list', null, 'width:100%;direction:ltr;');
		$table->addTR();
		$table->addTH('#', 'width:15px;');
		$table->addTH(__('Original'));
		$table->addTH(__('Translation'));
		for ($i=0; $i < count($catalog->strings); $i++) {
		$str = $catalog->strings[$i];
			$table->addTR('onclick="translate.translate('.$i.');"');
			$table->addTD('<img style="cursor:pointer;" src="images/'.($str->is_fuzzy ? 'unpublished' : 'published').'.gif" onclick="translate.fuzzy(this, $(\'fuzzy_'.$i.'\'));" /> <input type="hidden" name="fuzzy_'.$i.'" id="fuzzy_'.$i.'" value="'.($str->is_fuzzy ? 'true' : 'false').'">');
			$table->addTD('<div style="height:20px;overflow:hidden;">'.$str->msgid.'</div> <textarea name="msgid_'.$i.'" id="msgid_'.$i.'" style="display:none;">'.$str->msgid.'</textarea>', 'text-align:left;');
			$table->addTD('<div id="msgstr_div_'.$i.'" style="height:20px;overflow:hidden;">'.$str->msgstr.'</div> <textarea name="msgstr_'.$i.'" id="msgstr_'.$i.'" style="display:none;">'.$str->msgstr.'</textarea>', 'text-align:left;');
		}
		$table->show();
		echo '</div>
		<br />
		<div style="border:1px solid #ccc;direction:ltr;">
			<div style="padding:10px;" id="left">
			<b>'.__('Original').'</b><br />
			<textarea id="msgid" class="input" style="width:400px;height:150px;background:#eee;" readonly="readonly" dir="ltr"></textarea>
			</div>
			<div style="padding:10px;" id="right">
			<b>'.__('Translation').'</b><br />
			<textarea id="msgstr" class="input" style="width:400px;height:150px;background:#fff;" onblur="translate.update();"></textarea>
			</div>
			<div class="clear"></div>
		</div>';
		echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"').' ';
		echo AppleHTML::makeResetButton('id="cancel"').' ';
		echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=languages&task=translate&id='.$id.'&lng='.LANGUAGE.'\'"');
		echo '</form>';
	}
}
?>