<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

require_once(settings::get('root_path').'/configuration.php');
require_once(settings::get('root_path').'/settings.php');

$task = AppleGetParam('task', $_REQUEST, 'login');

$user = Appleuser::getInstance();
$log = new log();

switch ($task) {
	case 'login': $log->login(); break;
	case 'forget': $log->forget(); break;
	case 'logout': $log->logout(); break;
	default:$log->login();
}

class log {
	public $message;
	
	public function __construct() {
		$this->message = AppleMessage::getInstance();
	}
	
	public function login() {
		global $user;
		
		if ($user->id == 0) {
			if (AppleGetParam('username', $_POST) == null && AppleGetParam('password', $_POST) == null) {
				$this->loginForm();
			}
			elseif ($user->checkUser() == null) {
				$this->message->add('error', __('Incorrect username , password'));
				AppleGoBack();
			}
			else {
				AppleRedirect('index.php');
			}
		}
		else {
				AppleRedirect('index.php');
			}
	}
	
	public function forget() {
		global $user;
		if ($user->id > 0) AppleRedirect('index.php');
		if (!AppleGetParam('username', $_POST) && !AppleGetParam('email', $_POST))
			$this->forgetForm();
		else {
			$msg = $user->resetPassword();
			if ($msg == 'new password sent') {
				$this->message->add('success', __($msg));
				AppleRedirect('?com=login&task=forget');
			}
			else {
				$this->message->add('error', __($msg));
				AppleRedirect('?com=login&task=forget');
			}
		}
	}
	
	public function logout() {
		global $user;
		$user->logout();
		$this->login();
	}
	
	public function loginForm() {
		echo '<html>
		<head>
		<base href="'.settings::get('url').'/admin/" />
		<title>'.__('Login').'</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<link rel="stylesheet" type="text/css" href="themes/Apple/style.css" />
		</head>
		<body>
		<table width="600" cellpadding="0" cellspacing="0" border="0" align="center" style="margin-top:100px;">
		<tr>
		<td class="td-header-l">&nbsp;</td><td class="td-header" style="font-weight: bold;">'.__('Login to management').'</td><td class="td-header-r">&nbsp;</td>
		</tr>
		<tr>
		<td class="td-body-l">&nbsp;</td>
		<td class="td-body" valign="top"><br>
		<form action="?com=login" method="post">
		<table cellpadding="2" cellspacing="2" border="0" align="center" dir="rtl">
		<tr>
		<td colspan="3"><img src="images/logo-login.gif"></td>
		</tr>
		<tr>
		<td class="message" colspan="3">'.AppleShowMessage().'</td>
		</tr>
		<tr>
		<td>'.__('Username').' : </td>
		<td>'.AppleHTML::makeText('username', null, 'dir="ltr"', true).'</td>
		</tr>
		<tr>
		<td>'.__('Password').' : </td>
		<td>'.AppleHTML::makePassword('password').'</td>
		</tr>
		<tr>
		<td valign="top"><input type="submit" class="button" id="save" value="&nbsp;&nbsp;'.__('Login').'&nbsp;&raquo;&nbsp;&nbsp;"></td>
		<td style="padding-bottom:60px;" valign="top"><input type="button" class="button" id="delete" onclick="location.href=\''.AppleMakeSef('?com=login&task=forget').'\';" value="&nbsp;&nbsp;&nbsp;&nbsp;'.__('Forget your password?').'&nbsp;&nbsp;&nbsp;&nbsp;"></td>
		</tr>
		</table>
		</form>
		</td><td class="td-body-r">&nbsp;</td>
		</tr>
		<tr>
		<td class="td-footer-l">&nbsp;</td><td class="td-footer">&nbsp;</td><td class="td-footer-r">&nbsp;</td>
		</tr>
		</table>
		</body>
		</html>';
	}
	
	public function forgetForm() {
		echo '<html>
		<head>
		<base href="'.settings::get('url').'/admin/" />
		<title>'.__('Password recovery').'</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<link rel="stylesheet" type="text/css" href="themes/Apple/css/style.css" />
		</head>
		<body>
		<table width="600" cellpadding="0" cellspacing="0" border="0" align="center" style="margin-top:100px;">
		<tr>
		<td class="td-header-l">&nbsp;</td><td class="td-header" style="font-weight: bold;">'.__('Password recovery').'</td><td class="td-header-r">&nbsp;</td>
		</tr>
		<tr>
		<td class="td-body-l">&nbsp;</td>
		<td class="td-body" valign="top"><br>
		<form action="'.AppleMakeSef('?com=login&task=forget').'" method="post">
		<table border="0" align="center" dir="rtl">
		<tr>
		<td colspan="3"><img src="images/logo-login.gif"></td>
		</tr>
		<tr>
		<td class="message" colspan="3">'.AppleShowMessage().'</td>
		</tr>
		<tr>
		<td>'.__('Username').' : </td>
		<td>'.AppleHTML::makeText('username', null, 'dir="ltr"', true).'</td>
		</tr>
		<tr>
		<td>'.__('E-Mail').' : </td>
		<td>'.AppleHTML::makeText('email', null, 'dir="ltr"', true).'</td>
		</tr>
		<tr>
		<td valign="top"><input type="submit" class="button" id="save" value="&nbsp;&nbsp;'.__('Send').'&nbsp;&raquo;&nbsp;&nbsp;"></td>
		<td style="padding-bottom:60px;" valign="top"><input type="button" class="button" id="cancel" onclick="location.href=\'?\';" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.__('Back to login page').'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"></td>
		</tr>
		</table>
		</form>
		</td><td class="td-body-r">&nbsp;</td>
		</tr>
		<tr>
		<td class="td-footer-l">&nbsp;</td><td class="td-footer">&nbsp;</td><td class="td-footer-r">&nbsp;</td>
		</tr>
		</table>
		</body>
		</html>';
	}
}
?>