<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class menu {
	
	public $database;
	
	public function __construct() {
		$this->database = db::getInstance();
	}
	
	public function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__menu` WHERE lng='".LANGUAGE."'");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		$this->database->setQuery("SELECT * FROM `#__menu` WHERE lng='".LANGUAGE."' ORDER BY ordering $page_nav->sql_limit");
		$list = $this->database->loadObjectList();
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		if ($task == 'edit') {
			$this->database->setQuery("SELECT * FROM `#__menu` WHERE id='$id'");
			$object = $this->database->loadObject();
		}
		return $object;
	}
	
	public function save($task) {
		$id = AppleGetParam('id', $_GET, 0);
		$page = intval(AppleGetParam('page', $_POST, 1));
		$name = AppleGetParam('name', $_POST, null);
		$published = intval(AppleGetParam('published', $_POST, 0));
		
		$message = AppleMessage::getInstance();
		
		if ($name == null) {
			$message->add('error', __('Please enter menu name.'));
			return false;
		}
		
		if ($task == 'edit') {
			$this->database->setQuery("UPDATE `#__menu` SET name='$name', published='$published' WHERE id='$id'");
			if ($this->database->query()) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			$this->database->setQuery("INSERT INTO `#__menu` (name, published, lng) VALUES ('$name', '$published', '".LANGUAGE."')");
			$this->database->setQuery("INSERT INTO `#__modules` (title, show_title, module, position, style, published, ordering , lng) VALUES ('$name', 0, 'menu', 1, 'vertical', $published, 1, '".LANGUAGE."')");
			if ($this->database->query()) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete() {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++){
			$this->database->setQuery("DELETE FROM `#__menu` WHERE `id`='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
		}
		elseif ($this->database->getErrorNum() == 1451) {
			$message->add('error', __('menu has some items. first delete them'));
			return false;
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function publish($p) {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<count($id); $i++){
			$this->database->SetQuery("UPDATE `#__menu` SET `published`='$p' WHERE `id`='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		$message->add('error', __('unknown_error'));
		return false;
	}
	
	public function reOrder() {
		$message = AppleMessage::getInstance();
		if (AppleAjaxRequest()) {
			$sort = AppleGetParam('sort', $_POST);
			if ($sort == null) {
				$message->add('success', __('Changes updated successfully'));
				echo AppleShowMessage();
				return true;
			}
			
			$count = count(explode('&', $sort));
			
			parse_str($sort);
			
			$ab = array();
			$a = $tb_list;
			sort($a);
			
			$p=0;
			for ($i=0; $i<$count; $i++) {
				$ab[$tb_list[$i]['id']] = $a[$p++]['id'];
			}
			foreach ($ab as $k=>$v) {
				$this->database->setQuery("UPDATE `#__menu` SET `ordering`=$v WHERE id=$k");
				if (!$this->database->query()) {
					$message->add('error', __('Queries are done with error'));
					echo AppleShowMessage();
					return false;
				}
			}
			$message->add('success', __('Changes updated successfully'));
			echo AppleShowMessage();
			return true;
		}
		else {
			$id = AppleGetParam('id', $_GET);
			$do = AppleGetParam('do', $_GET, 'up');
			
			$this->database->sort('`#__menu`', $id, ''.$do.'');
		}
	}
}

class item {
	
	public $database;
	
	public function __construct() {
		$this->database = db::getInstance();
	}
	
	public function view() {
		$id = intval(AppleGetParam('id', $_GET, 1));
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__menu_items`
		WHERE menu=$id");
		$count = $this->database->loadObject();
		$count = $count->count;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		$limit_start = ($page_nav->page-1)*$page_nav->limit;
		$list = AppleMakeTree('#__menu_items', 0, "menu=$id", true, $limit_start, $page_nav->limit);
		return array($list, $page_nav);
	}
	
	public function form($task, $id) {
		if ($_POST) {
			$object = new stdClass();
			$object->menu = intval(AppleGetParam('menu', $_POST, 0));
			$object->parent = intval(AppleGetParam('parent', $_POST, 0));
			$object->url = AppleGetParam('url', $_POST, null);
			$object->title = AppleGetParam('title', $_POST, null);
			$object->image = AppleGetParam('image', $_POST, null);
			$object->target = AppleGetParam('target', $_POST, '_self');
			$object->internal = intval(AppleGetParam('internal', $_POST, 1));
			$object->ispage = AppleGetParam('com', $_POST, null) == '' ? 1 : 0;
			$object->published = intval(AppleGetParam('published', $_POST, 0));
		}
		elseif ($task == 'edit') {
			$this->database->setQuery("SELECT * FROM `#__menu_items` WHERE id='$id'");
			$object = $this->database->loadObject();
		}
		return $object;
	}
	
	public function save($task) {
		$id = AppleGetParam('id', $_GET, 0);
		$menu = intval(AppleGetParam('menu', $_GET, 1));
		$page = intval(AppleGetParam('page', $_POST, 0));
		
		$obj = new stdClass();
		$obj->menu = intval(AppleGetParam('menu', $_POST, 0));
		$obj->parent = intval(AppleGetParam('parent', $_POST, 0));
		$obj->url = AppleGetParam('url', $_POST, null);
		$obj->title = AppleGetParam('title', $_POST, null);
		$obj->image = AppleGetParam('image', $_POST, null);
		$obj->icon = AppleGetParam('icon', $_POST, null);
		$obj->target = AppleGetParam('target', $_POST, '_self');
		$obj->internal = intval(AppleGetParam('internal', $_POST, 1));
		$obj->ispage = AppleGetParam('com', $_POST, null) == '' ? 1 : 0;
		$obj->published = intval(AppleGetParam('published', $_POST, 0));
		
		$message = AppleMessage::getInstance();
		
		if ($obj->title == null) {
			$message->add('error', __('Please enter item name.'));
			return false;
		}
		if ($obj->url == null) {
			$message->add('error', __('Please enter item url.'));
			return false;
		}
		if ($obj->menu == 0) {
			$message->add('error', __('Please select menu.'));
			return false;
		}
		
		if ($task == 'edit') {
			if ($this->database->update('`#__menu_items`', $obj, "id=$id")) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
		else {
			if ($this->database->insert('`#__menu_items`', $obj)) {
				$message->add('success', __('Changes updated successfully'));
				return true;
			}
			else {
				$message->add('error', __('unknown_error'));
				return false;
			}
		}
	}
	
	public function delete() {
		$page = AppleGetParam('page', $_GET, 1);
		$menu = intval(AppleGetParam('menu', $_GET, 1));
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++){
			$this->database->setQuery("DELETE FROM `#__menu_items` WHERE `id`='$id[$i]'");
		}
		
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
			
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function publish($p) {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<count($id); $i++){
			$this->database->SetQuery("UPDATE `#__menu_items` SET `published`='$p' WHERE `id`='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		$message->add('error', __('unknown_error'));
		return false;
	}
	
	public function getMenuList() {
		global $database;
		$database->setQuery("SELECT * FROM `#__menu` WHERE lng='".LANGUAGE."'");
		return $database->loadObjectList();
	}
	
	public function getParent($id) {
		global $database;
		$database->setQuery("SELECT name FROM `#__menu_items` WHERE id='$id'");
		$parent = $database->loadObject();
		return ($parent->name != null) ? $parent->name : '-';
	}
	
	public function reOrder() {
		$message = AppleMessage::getInstance();
		
		if (AppleAjaxRequest()) {
			$level = AppleGetParam('level', $_POST);
			$sort = AppleGetParam('sort', $_POST);
			if ($level == null || $sort == null) {
				$message->add('success', __('Changes updated successfully'));
				echo AppleShowMessage();
				return true;
			}
			
			$count = count(explode('&', $level));
			
			parse_str($level);
			parse_str($sort);
			
			$ab = array();
			
			foreach ($level as $k=>$a) {
				sort($a);
				$p = 0;
				for ($i=0; $i<$count; $i++) {
					if (in_array($tb_list[$i]['id'], $a)) {
						$ab[$tb_list[$i]['id']] = $a[$p++];
					}
				}
			}
			
			foreach ($ab as $k=>$v) {
				$this->database->setQuery("UPDATE `#__menu_items` SET `ordering`=$v WHERE id=$k");
				if (!$this->database->query()) {
					$message->add('error', __('Queries are done with error'));
					echo AppleShowMessage();
					return false;
				}
			}
			$message->add('success', __('Changes updated successfully'));
			echo AppleShowMessage();
			return true;
		}
		else {
			$id = AppleGetParam('id', $_GET);
			$do = AppleGetParam('do', $_GET, 'up');
			
			$this->database->sort('`#__menu_items`', $id, ''.$do.'', 'menu,parent');
		}
	}
	
	public function getComponents() {
		global $database;
		$database->setQuery("SELECT * FROM `#__components`");
		$list = $database->loadObjectList();
		$ret = array(AppleHTML::makeOption('', '----'));
		if (!empty($list)) {
			foreach ($list as $k) {
				$ret[] = AppleHTML::makeOption($k->name, $k->name);
			}
		}
		return $ret;
	}
}
?>