<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class menuHTML {
	function view($list, $page_nav) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		AppleSetPath(__('Menu Management'));
		?>
		<form action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		$action[] = AppleHTML::makeOption('new', __('New'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		$action[] = AppleHTML::makeOption('publish', __('Publish'));
		$action[] = AppleHTML::makeOption('unpublish', __('Unpublish'));
		
		$table = new table(null, null, 'width:700px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'action', 'id="action"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'action\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'action\').value != \'\' && $(\'action\').value != \'delete\')) submitButton(this.form, $(\'action\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:700px;');
		$table->sortable = true;
		$table->sort_url = '?com=menu&task=reorder';
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('<input type="checkbox" onClick="checkAll(this);">', 'width:5px;');
		$table->addTH(__('Name'), 'width:400px;');
		$table->addTH(__('Items'), 'width:50px;');
		$table->addTH(__('Publish'), 'width:50px;');
		$table->addTH(__('Reorder'), 'width:50px;', 'colspan="2"');
		$table->addTH(__('Edit'), 'width:30px;');
		$table->addTH(__('Delete'), 'width:30px;');
		
		@reset($list);
		$i = 0;
		$p = ($page-1)*$page_nav->limit_length;
		if (!empty($list)) {
			foreach ($list as $item) {
				$i++;
				$table->addTR("id=\"tr_$item->id\"");
				$table->addTD(++$p);
				$table->addTD('<input type="checkbox" id="'.$item->id.'">');
				$table->addTD('<a href="?com=menu&task=edit&id='.$item->id.'&page='.$page.'&lng='.LANGUAGE.'">'.$item->name.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				$table->addTD('<a href="?com=menu&section=items&id='.$item->id.'&lng='.LANGUAGE.'">'.__('Items').'</a>');
				$table->addTD(AppleHTML::publishIcon($item->id, $item->published));
				//$table->addTD(AppleHTML::moveUpIcon($item->id, $list[$i-2] != null));
				//$table->addTD(AppleHTML::moveDownIcon($item->id, $list[$i] != null));
				$table->addTD('<img src="images/move.gif" />', null, 'colspan=2');
				$table->addTD(AppleHTML::editIcon($item->id));
				$table->addTD(AppleHTML::deleteIcon($item->id, 'list'));
			}
		}
		
		$table->show();
		?>
		<input type="hidden" name="com" value="menu" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="" />
		<input type="hidden" name="page" value="<?php echo $page; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
		echo $page_nav->writePages();
	}
	
	function form($task, $object=null) {
		$id = intval(AppleGetParam('id', $_GET, 0));
		$page = intval(AppleGetParam('page', $_GET, 1));
		if ($task == 'new') AppleSetPath(__('New Menu'));
		else AppleSetPath(__('Edit Menu'));
		?>
		<form action="?com=menu&task=<?php echo $task; ?>&id=<?php echo $id; ?>&lng=<?php echo LANGUAGE; ?>" method="POST">
		<table width="100%" border="0">
		<tr>
		<td valign="top" width="40%">
		<table border="0">
		<tr>
		<td><?php _e('Name'); ?> :</td><td><?php echo AppleHTML::makeText('name', $object->name); ?></td>
		</tr>
		<tr>
		<td></td>
		<td><label for="published"><?php _e('Publish Status'); ?> : <input type="checkbox" name="published" id="published" value="1" <?php if ($object->published == 1 || $task == 'new') echo 'checked="checked"'; ?>></label></td>
		</tr>
		<tr><td colspan="2">
		<input type="hidden" name="page" value="<?php echo $page ?>" />
		
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=menu&page='.$page.'&lng='.LANGUAGE.'\'"'); ?>
		</td></tr>
		</table>
		</td>
		</tr>
		</table>
		</form>
		<?php
	}
}

class itemsHTML {
	function view($list, $page_nav) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		$menu = intval(AppleGetParam('id', $_GET, 1));
		AppleSetPath(__('Menu Management'));
		?>
		<form name="items" id="items" action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		$action[] = AppleHTML::makeOption('new', __('New'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		$action[] = AppleHTML::makeOption('publish', __('Publish'));
		$action[] = AppleHTML::makeOption('unpublish', __('Unpublish'));
		
		$table = new table(null, null, 'width:800px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'action', 'id="action"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'action\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'action\').value != \'\' && $(\'action\').value != \'delete\')) submitButton(this.form, $(\'action\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:800px;');
		$table->sortable = true;
		$table->sort_url = '?com=menu&section=items&task=reorder';
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('<input type="checkbox" onClick="checkAll(this);">', 'width:5px;');
		$table->addTH(__('Name'), 'width:400px;');
		$table->addTH(__('Parent name'), 'width:100px;');
		//$table->addTH(__('menu name'), 'width:100px;');
		$table->addTH(__('Publish'), 'width:50px;');
		$table->addTH(__('Reorder'), 'width:50px;', 'colspan="2"');
		$table->addTH(__('Edit'), 'width:30px;');
		$table->addTH(__('Delete'), 'width:30px;');
		
		@reset($list);
		$i = 0;
		$p = ($page-1)*$page_nav->limit_length;
		if (!empty($list)) {
			$level = array();
			$x = array();
			foreach ($list as $item) {
				$i++;
				$table->addTR("id=\"tr_$item->id\"");
				$table->addTD(++$p);
				$table->addTD('<input type="checkbox" id="'.$item->id.'">');
				$level[$item->level] = $item->id;
				$x[] = 'level['.$item->level.'][]='.$item->id;
				$name = null;
				for ($j=0; $j<$item->level; $j++) $name .= '&nbsp;&nbsp;.&nbsp;&nbsp;';
				$name .= $item->title;
				$table->addTD('<a href="?com=menu&section=items&menu='.$menu.'&task=edit&id='.$item->id.'&page='.$page.'&lng='.LANGUAGE.'">'.$name.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				$table->addTD(item::getParent($item->id) == '-' ?  item:: getParent($item->id) : '<a href="?com=menu&section=items&task=edit&id='.$item->parent.'&page='.$page.'&lng='.LANGUAGE.'">'.item::getParent($item->id).'</a>');
				
				$table->addTD(AppleHTML::publishIcon($item->id, $item->published));
				//$table->addTD(AppleHTML::moveUpIcon($item->id, $list[$i-2] != null));
				//$table->addTD(AppleHTML::moveDownIcon($item->id, $list[$i] != null));
				$table->addTD('<img src="images/move.gif" />', null, 'colspan=2');
				$table->addTD(AppleHTML::editIcon($item->id));
				$table->addTD(AppleHTML::deleteIcon($item->id, 'list'));
			}
			echo '<div id="level" style="display:none;">'.implode('&', $x).'</div>';
		}
		
		$table->show();
		?>
		<input type="hidden" name="com" value="menu" />
		<input type="hidden" name="section" value="items" />
		<input type="hidden" name="menu" value="<?php echo $menu; ?>" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="" />
		<input type="hidden" name="page" value="<?php echo $page; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
		echo $page_nav->writePages();
	}
	
	function form($task, $object=null) {
		$id = intval(AppleGetParam('id', $_GET, 0));
		$page = intval(AppleGetParam('page', $_GET, 1));
		$menu1 = intval(AppleGetParam('menu', $_GET, 1));
		$menu = !empty($object) ? $object->menu : intval(AppleGetParam('menu', $_GET, 1));
		
		if ($object->ispage == 0) {
			if ($object->url == '?lng='.LANGUAGE) {
				$object->com = settings::get('default_component');
			}
			else {
				$object->com = preg_split("/(com=+[^&]+(&)?)/", $object->url, -1, PREG_SPLIT_DELIM_CAPTURE);
				$object->com = str_replace('com=', '', $object->com[1]);
				$object->com = str_replace('&', '', $object->com);
			}
		}
		
		if ($task == 'new') AppleSetPath(__('New Menu'));
		else AppleSetPath(__('Edit Menu'));
		?>
		<form action="?com=menu&section=items&menu=<?php echo $menu1; ?>&task=<?php echo $task; ?>&id=<?php echo $id; ?>&lng=<?php echo LANGUAGE; ?>" method="POST">
		<table width="100%" border="0">
		<tr>
		<td valign="top" width="40%">
		<table border="0">
		<tr>
		<td><?php _e('Title'); ?> :</td><td> <input type="text" class="input" name="title" value="<?php echo $object->title; ?>"></td>
		</tr>
		<tr>
		<td><?php _e('Link'); ?> :</td><td> <input type="text" class="input" name="url" id="url" value="<?php echo $object->url; ?>" <?php if ($object->com != null) echo "readonly"; ?> dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('Image Address'); ?> :</td><td> <input type="text" class="input" name="image" value="<?php echo $object->image; ?>" dir="ltr"></td>
		</tr>
		<tr>
		<td><?php _e('Menu Icon'); ?> :</td><td> <input type="text" class="input" name="icon" value="<?php echo $object->icon; ?>" dir="ltr"></td>
		</tr>
		<?php
		$type = array();
		$type[] = AppleHTML::makeOption('1', __('Internal'));
		$type[] = AppleHTML::makeOption('0', __('External'));
		?>
		<tr>
		<td><?php _e('Link Type'); ?> :</td><td><?php echo AppleHTML::makeList($type, 'internal', 'id="internal"', $object->internal); ?></td>
		</tr>
		<tr>
		<td><?php _e('Component'); ?> :</td><td><?php echo AppleHTML::makeList(item::getComponents(), 'com', 'id="com" onchange="if (this.value == \'\') $(\'url\').readOnly=false; else {var x=(this.value!=\''.settings::get('default_component').'\')?\'?com=\'+this.value+\'&\':\'?\';$(\'url\').value=\'\'+x+\'lng='.LANGUAGE.'\';$(\'internal\').value=1;$(\'url\').readOnly=true;}"', $object->com); ?></td>
		</tr>
		<tr>
		<td><?php _e('Parent Name'); ?> :</td><td> <select class="input" name="parent">
		<option value="0">----</option>
		<?php
		$list = AppleMakeTree('#__menu_items', 0, "id != '$id' AND `menu` IN (SELECT id FROM `#__menu` WHERE lng='".LANGUAGE."')", true, 0, 0);
		if ($list != null) {
			foreach ($list as $c) {
				echo '<option value="'.$c->id.'" '; if ($c->id == $object->parent) echo 'selected="selected"'; echo '>'; for ($i=0; $i<$c->level; $i++) echo '&nbsp;.&nbsp;';echo $c->title.'</option>';
			}
		}
		?>
		</select>
		</td>
		</tr>
		<tr>
		<td><?php _e('Menu Name'); ?> :</td><td> <select class="input" name="menu">
		<?php
		$list = item::getMenuList();
		if ($list != null) {
			foreach ($list as $c) {
				echo '<option value="'.$c->id.'" '; if ($c->id == $menu) echo 'selected="selected"'; echo '>'.$c->name.'</option>';
			}
		}
		?>
		</select>
		</td>
		</tr>
		<?php
		$target = array();
		$target[] = AppleHTML::makeOption('_self', __('Open in The same Window'));
		$target[] = AppleHTML::makeOption('_blank', __('Open in New Window'));
		?>
		<tr>
		<td><?php _e('Target'); ?> : </td>
		<td><?php echo AppleHTML::makeList($target, 'target', 'id="target"', $object->target); ?></td>
		</tr>
		<?php
		$pub = array();
		$pub[] = AppleHTML::makeOption('0', __('Unpublish'));
		$pub[] = AppleHTML::makeOption('1', __('Publish'));
		?>
		<tr>
		<td><?php _e('Publish Status'); ?> : </td>
		<td><?php echo AppleHTML::makeList($pub, 'published', 'id="published"', ($object->published || $task == 'new')); ?></td>
		</tr>
		<tr><td colspan="2">
		<input type="hidden" name="page" value="<?php echo $page ?>" />
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=menu&section=items&id='.$menu1.'&page='.$page.'&lng='.LANGUAGE.'\'"'); ?>
		</td></tr>
		</table>
		</td>
		</tr>
		</table>
		</form>
		<?php
	}
}
?>