<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class modules {
	public $database;
	
	public function __construct() {
		$this->database = db::getInstance();
	}
	
	public function view() {
		$limit_length = 25;
		$this->database->setQuery("SELECT COUNT(*) as count FROM `#__modules`");
		$count = $this->database->loadObject();
		$count = $count->count;
		$lng = LANGUAGE;
		
		$page_nav = new ApplePageNav($count, $limit_length);
		
		$this->database->setQuery("SELECT a.*, b.position as position, c.menu as page FROM `#__modules` as a 
		LEFT JOIN `#__theme_positions` as b ON a.position=b.id 
		LEFT JOIN `#__modules_positions` as c ON a.id=c.id
		WHERE `lng`='$lng'
		GROUP BY a.id 
		ORDER BY a.position,a.ordering $page_nav->sql_limit");
		$list = $this->database->loadObjectList();
		return array($list, $page_nav);
	}
	
	public function copyModule() {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		$titles = null;
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++) {
			$this->database->setQuery("SELECT * FROM `#__modules` WHERE `id`='$id[$i]'");
			$module = $this->database->loadObject();
			$titles .= $module->title;
			$module->title .= ' ['.__('Copy').']';
			
			$mid = $this->database->insert('`#__modules`', $module, 'id');
			if ($mid == 0) {
				$message->add('error', __('unknown_error'));
				return false;
			}
			$this->database->setQuery("SELECT * FROM `#__modules_params` WHERE `id`='$id[$i]'");
			$params = $this->database->loadObjectList();
			foreach ($params as $param) {
				$this->database->setQuery("INSERT INTO `#__modules_params` (id, `key`, `value`) VALUES ('$mid', '".$param->key."', '".$param->value."')");
			}
			$this->database->query();
			$this->database->setQuery("SELECT * FROM `#__modules_positions` WHERE `id`='$id[$i]'");
			$objects = $this->database->loadObjectList();
			foreach ($objects as $obj) {
				$this->database->setQuery("INSERT INTO `#__modules_positions` (id, menu) VALUES ('$mid', '".$obj->menu."')");
			}
			$this->database->query();
		}
		$message->add('success', sprintf(__('"%s" copied.'), $titles));
		return true;
	}
	
	public function form() {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$id = intval($id[0]);
		$this->database->setQuery("SELECT * FROM `#__modules` WHERE id='$id'");
		$module = $this->database->loadObject();
		
		$module->param = AppleGetParams('`#__modules_params`', $id, 'key');
		
		$this->database->setQuery("SELECT * FROM `#__theme_positions`");
		$positions = $this->database->loadObjectList();
		
		$this->database->setQuery("SELECT * FROM `#__modules_positions` WHERE id='$id'");
		$module->pages = $this->database->loadRowList();
		$temp = array();
		if ($module->pages != null) {
			foreach ($module->pages as $ob) {
				$temp[] = $ob[1];
			}
			$module->pages = $temp;
		}
		
		$temp = array(new stdClass());
		$temp[0]->id = 0;
		$temp[0]->title = __('All Pages');
		
		$this->database->setQuery("SELECT * FROM `#__menu_items` WHERE `internal`=1");
		$pages = $this->database->loadObjectList();
		$pages = array_merge($temp,  $pages);
		
		//Read from xml file
		if (file_exists(settings::get('root_path').'/modules/'.$module->module.'/index.xml')) {
			$xml = new AppleModuleParser(settings::get('root_path').'/modules/'.$module->module.'/index.xml', $module->param);
			$module->xml->out = implode("\n", $xml->out);
			$module->xml->description = $xml->getTag('description');
			$module->xml->params = implode(",", $xml->params);
		}
		else {
			$module->xml->out = null;
			$module->xml->description = null;
			$module->xml->params = null;
		}
		
		return array($module, $positions, $pages);
	}
	
	public function save() {
		$page = intval(AppleGetParam('page', $_GET, 1));
		$id = intval(AppleGetParam('id', $_GET, 1));
		$title = AppleGetParam('title', $_POST);
		$show_title = intval(AppleGetParam('show_title', $_POST, 1));
		$style = AppleGetParam('style', $_POST);
		$position = intval(AppleGetParam('position', $_POST, 1));
		$published = intval(AppleGetParam('published', $_POST, 0));
		$params = explode(',', AppleGetParam('params', $_POST));
		$pages = AppleGetParam('pages', $_POST);
		
		$message = AppleMessage::getInstance();
		
		if ($title == null) {
			$message->add('error', __('Please enter module title'));
			return false;
		}
		
		$this->database->setQuery("DELETE FROM `#__modules_params` WHERE id='$id'");
		$this->database->setQuery("DELETE FROM `#__modules_positions` WHERE id='$id'");
		$this->database->setQuery("UPDATE `#__modules` SET title='$title', `show_title`='$show_title', `style`='$style', `position`='$position', `published`='$published' WHERE id='$id'");
		
		if ($params != null) {
			foreach ($params as $k) {
				$k = str_replace('[]', '', $k);
				$v = AppleGetParam($k, $_POST);
				if ($k == null || $v == null) continue;
				if (is_array($v)) $v = implode(',', $v);
				$k = str_replace('param_', '', $k);
				$this->database->setQuery("INSERT INTO `#__modules_params` VALUES('$id', '$k', '$v')");
			}
		}
		
		if ($pages != null) {
			foreach ($pages as $k => $v) {
				$this->database->setQuery("INSERT INTO `#__modules_positions` VALUES('$id', '$v')");
			}
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		else {
			$message->add('error', __('unknown_error'));
			return false;
		}
	}
	
	public function delete() {
		$page = intval(AppleGetParam('page', $_GET, 1));
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$count = count($id);
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<$count; $i++) {
			$this->database->setQuery("DELETE FROM `#__modules` WHERE `id`='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			if (AppleAjaxRequest()) {
				for ($i=0; $i<$count; $i++) {
					echo '<script>AppleList.remove(\'tr_'.$id[$i].'\', \''.AppleGetParam('tb', $_GET).'\');</script>';
				}
			}
			return true;
			
		}
		elseif ($count == 1) {
			$message->add('error', __('unknown_error'));
			return false;
		}
		else {
			$message->add('error', __('Queries are done with error'));
			return false;
		}
	}
	
	public function publish($p) {
		$id = AppleGetParam('id', $_GET);
		$id = explode(',',$id);
		$message = AppleMessage::getInstance();
		
		for ($i=0; $i<count($id); $i++){
			$this->database->SetQuery("UPDATE `#__modules` SET `published`='$p' WHERE `id`='$id[$i]'");
		}
		if ($this->database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		else
			$message->add('error', __('unknown_error'));
			return false;
	}
	
	public function reOrder() {
		$message = AppleMessage::getInstance();
		if (AppleAjaxRequest()) {
			$sort = AppleGetParam('sort', $_POST);
			if ($sort == null) {
				$message->add('success', __('Changes updated successfully'));
				echo AppleShowMessage();
				return true;
			}
			
			$count = count(explode('&', $sort));
			
			parse_str($sort);
			
			$ab = array();
			$a = $tb_list;
			sort($a);
			
			$p=0;
			for ($i=0; $i<$count; $i++) {
				$ab[$tb_list[$i]['id']] = $a[$p++]['id'];
			}
			foreach ($ab as $k=>$v) {
				$this->database->setQuery("UPDATE `#__modules` SET `ordering`=$v WHERE id=$k");
				if (!$this->database->query()) {
					$message->add('error', __('Queries are done with error'));
					echo AppleShowMessage();
					return false;
				}
			}
			$message->add('success', __('Changes updated successfully'));
			echo AppleShowMessage();
			return true;
		}
		else {
			$id = AppleGetParam('id', $_GET);
			$do = AppleGetParam('do', $_GET, 'up');
			
			$this->database->sort('`#__modules`', $id, ''.$do.'', 'position');
		}
	}
}
?>