<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class HTML {
	function view($list, $page_nav) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		AppleSetPath(__('Manage Modules'));
		?>
		<form name="modules" id="modules" action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		$action[] = AppleHTML::makeOption('copy', __('Copy'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		$action[] = AppleHTML::makeOption('publish', __('Publish'));
		$action[] = AppleHTML::makeOption('unpublish', __('Unpublish'));
		
		$table = new table(null, null, 'width:900px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'action', 'id="action"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'action\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'action\').value != \'\' && $(\'action\').value != \'delete\')) submitButton(this.form, $(\'action\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:900px;');
		$table->sortable = true;
		$table->sort_url = '?com=modules&task=reorder';
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('<input type="checkbox" onClick="checkAll(this);">', 'width:5px;');
		$table->addTH(__('Title'), 'width:400px;');
		$table->addTH(__('Publish'), 'width:50px;');
		$table->addTH(__('Reorder'), 'width:50px;', 'colspan="2"');
		$table->addTH(__('Position'), 'width:50px;');
		$table->addTH(__('Page'), 'width:150px;');
		$table->addTH(__('Edit'), 'width:30px;');
		$table->addTH(__('Delete'), 'width:30px;');
		$table->addTH(__('Module'), 'width:50px;');
		$table->addTH('ID', 'width:50px;');
		
		@reset($list);
		$i = 0;
		$p = ($page-1)*$page_nav->limit_length;
		if (!empty($list)) {
			foreach ($list as $item) {
				$i++;
				$table->addTR("id=\"tr_$item->id\"");
				$table->addTD(++$p);
				$table->addTD('<input type="checkbox" id="'.$item->id.'">');
				$table->addTD('<a href="?com=modules&task=edit&id='.$item->id.'&page='.$page.'&lng='.LANGUAGE.'">'.$item->title.'<a/>', 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
				$table->addTD(AppleHTML::publishIcon($item->id, $item->published));
				//$table->addTD(AppleHTML::moveUpIcon($item->id, $list[$i-2] != null));
				//$table->addTD(AppleHTML::moveDownIcon($item->id, $list[$i] != null));
				$table->addTD('<img src="images/move.gif" />', null, 'colspan=2');
				$table->addTD($item->position);
				$table->addTD($item->page == 0 ? __('All Pages') : __('Some Pages'));
				$table->addTD(AppleHTML::editIcon($item->id));
				$table->addTD(AppleHTML::deleteIcon($item->id, 'list'));
				$table->addTD($item->module, 'text-align:left;');
				$table->addTD($item->id);
			}
		}
		
		$table->show();
		?>
		<input type="hidden" name="com" value="modules" />
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="id" value="" />
		<input type="hidden" name="page" value="<?php echo $page; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
		echo $page_nav->writePages();
	}
	
	function form($module, $positions, $pages) {
		$page = intval(AppleGetParam('page', $_GET, 1));
		if ($task == 'new' && $id == 0) {
			AppleSetPath(__('New Module'));
		}
		else {
			AppleSetPath(__('Edit Module'));
		}
		echo '<form action="" method="post">
		<table width="95%" border="0" align="center">
		<tr>
		<td width="65%" valign="top">
			<table width="100%" cellpadding="2" cellspacing="2" border="0">
			<tr>
			<td style="width:100px;">'.__('Title').' : </td><td>'.AppleHTML::makeText('title', $module->title, 'id="title"', true).'</td>
			</tr>
			<tr>';
			$options = array();
			$options[] = AppleHTML::makeOption(1, __('Yes'));
			$options[] = AppleHTML::makeOption(0, __('No'));
			echo '<td style="width:100px;">'.__('Show Title').' : </td><td>'.AppleHTML::makeList($options, 'show_title', null, $module->show_title).'</td>
			</tr>
			<tr>
			<td style="width:100px;">'.__('Style').' : </td>
			<td>';
			$options = array();
			$options[] = AppleHTML::makeOption('vertical', __('Vertical'));
			$options[] = AppleHTML::makeOption('horizontal', __('Horizontal'));
			echo AppleHTML::makeList($options, 'style', null, $module->style).'</td>
			</tr>
			<tr>
			<td style="width:100px;">'.__('Position').' : </td>
			<td>'.AppleHTML::makeList($positions, 'position', null, $module->position, 'id', 'position').'</td>
			</tr>';
			
			//Read from xml file
			echo $module->xml->out;
			
			echo '<tr>
			<td style="width:100px;">'.__('Publish Status').' : </td>
			<td>';
			$pub = array();
			$pub[] = AppleHTML::makeOption('1', __('Publish'));
			$pub[] = AppleHTML::makeOption('0', __('Unpublish'));
			echo AppleHTML::makeList($pub, 'published', 'id="published"', $module->published);
			echo '</td>
			</tr>
			
			<tr><td>'.__('ID').' : </td><td>'.$module->id.'</td></tr>
			<tr><td>'.__('Description').' : </td><td>'.$module->xml->description.'</td></tr>
			</table>
		</td>
		<td valign="top">
			<table width="100%" border="0">
			<tr>
			<td>';
			echo AppleHTML::makeList($pages, 'pages[]', 'multiple style="width:200px; height:300px;"', $module->pages, 'id', 'title');
			echo '<input type="hidden" name="params" value="'.$module->xml->params.'" /></td>
			</tr>
			</table>
		</td>
		</tr>
		</table>
		'.AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"').'
		'.AppleHTML::makeResetButton('id="cancel"').'
		'.AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="location.href=\'?com=modules&page='.$page.'&lng='.LANGUAGE.'\'"').'
		</form>';
	}
}
?>