<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

$task = AppleGetParam('task', $_GET, 'list');
$user = AppleGetParam('user', $_GET, 'client');

switch ($task) {
	case 'edit': edit($user); break;
	case 'default':
		$obj = new edit($user);
		$obj->setAsDefault();
		AppleRedirect('?com=themes&user='.$user.'&lng='.LANGUAGE);
		break;
	case 'assign': assign($user); break;
	case 'delete': delete($user); break;
	case 'positions': positions(); break;
	default: listThemes($user);
}

function listThemes($user) {	
	$directory = ($user == 'client') ? settings::get('root_path').'/themes' : settings::get('root_path').'/admin/themes';
	$list = array();
	@$dir = opendir("$directory");
	if (!$dir) return ;
	
	while($theme=readdir($dir))
		if ($theme != '.' && $theme != '..' && is_dir("$directory/$theme"))	
			array_push($list, $theme);
			
	$display = new HTML();
	$display->listThemes($list, $user);
}

function edit($user) {
	$id = AppleGetParam('id', $_GET);
	$submit = AppleGetParam('save', $_POST);
	
	$theme = new stdClass();
	$theme->directory = ($user == 'client') ? settings::get('root_path').'/themes' : settings::get('root_path').'/admin/themes';
	$theme->user = $user;
	$theme->id = $id;
	
	if ($submit != null) {
		$obj = new edit($user);
		$obj->doEdit($theme);
		AppleRedirect('?com=themes&user='.$user.'&task=edit&id='.$theme->id.'&lng='.LANGUAGE);
	}
	else {
		$theme->content = @file_get_contents("$theme->directory/$id/index.tpl");
		$theme->css = @file_get_contents("$theme->directory/$id/style.css");
		
		$display = new HTML();
		$display->editTheme($theme);
	}
}

function assign($user) {
	$id = AppleGetParam('id', $_GET);
	$submit = AppleGetParam('save', $_POST);
	
	if ($submit == null) {
		global $database;
		
		$list = AppleMakeTree('`#__menu_items`', 0, 1, true, 0, 0);
		$pages = array();
		$pages[0]->id = -1;
		$pages[0]->title = 'Nothing';
		for ($i=1; $i<count($list); $i++) {
			$item = $list[$i-1];
			$pages[$i]->id = $item->id;
			$title = '';
			for ($j=0; $j<$item->level; $j++) $title .= '&nbsp;&nbsp;.&nbsp;&nbsp;';
			$pages[$i]->title = $title.$item->title;
		}
		
		$database->setQuery("SELECT * FROM `#__theme` WHERE theme='$id' AND lng='".LANGUAGE."'");
		$list = $database->loadRowList();
		$selected = array();
		if ($list != null) {
			foreach ($list as $ob) {
				$selected[] = $ob[1];
			}
		}
		
		$obj = new stdClass();
		$obj->user = $user;
		$obj->id = $id;
		$obj->pages = $pages;
		$obj->selected = $selected;
		$display = new HTML();
		$display->assign($obj);
	}
	else {
		$obj = new edit($user);
		$obj->assign();
		AppleRedirect('?com=themes&task=assign&id='.$id.'&lng='.LANGUAGE);
	}
}

function delete($user) {
	$obj = new edit($user);
	$obj->delete();
	AppleRedirect('?com=themes&user='.$user.'&lng='.LANGUAGE);
}

function positions() {
	$submit = AppleGetParam('save', $_POST, null);
	
	global $database;
	$database->setQuery("SELECT * FROM `#__theme_positions`");
	$list = $database->loadObjectList('id');
	
	if ($submit != null) {
		$obj = new positions();
		$obj->save($list);
		AppleRedirect('?com=themes&task=positions&lng='.LANGUAGE);
	}
	else {
		HTML::positions($list);
	}
}
?>