<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class edit {
	public $user;
	public $directory;
	
	function __construct($user) {
		$this->user = $user;
		$this->directory = ($this->user == 'client') ? settings::get('root_path').'/themes' : settings::get('root_path').'/admin/themes';
	}
	
	function doEdit($theme) {
		$theme->content = stripslashes(AppleGetParam('theme', $_POST, null, _MOS_ALLOWHTML));
		$theme->css = stripslashes(AppleGetParam('css', $_POST, null, _MOS_ALLOWHTML));
		$file = $this->directory.'/'.$theme->id.'/index.tpl';
		$css = $this->directory.'/'.$theme->id.'/style.css';
		$message = AppleMessage::getInstance();
		
		if (($fp = fopen($file, 'w')) && ($cs = fopen($css, 'w'))) {
			fputs($fp, $theme->content, strlen($theme->content));
			fputs($cs, $theme->css, strlen($theme->css));
			fclose($fp);
			fclose($cs);
			$message->add('success', __('Changes updated successfully'));
		}
		else $message->add('error', __('unknown_error'));
	}
	
	function setAsDefault() {
		if ($this->user != 'client') return ;
		global $database;
		$id = AppleGetParam('id', $_GET);
		$message = AppleMessage::getInstance();
		
		$database->setQuery("SELECT * FROM `#__theme` WHERE menu=0 AND lng='".LANGUAGE."'");
		$theme = $database->loadObject();
		if ($theme != null) {
			$theme->theme = $id;
			$r = $database->update('`#__theme`', $theme, "menu=0 AND lng='".LANGUAGE."'");
		}
		else {
			$theme->theme = $id;
			$theme->menu = 0;
			$theme->lng = LANGUAGE;
			$r = $database->insert('`#__theme`', $theme);
		}
		if ($r == true) $message->add('success', __('Changes updated successfully'));
		else $message->add('error', __('unknown_error'));
	}
	
	function assign() {
		if ($this->user != 'client') return ;
		global $database;
		$theme = AppleGetParam('id', $_POST);
		$menu = AppleGetParam('pages', $_POST);
		
		$m = implode(',', $menu);
		$database->delete('`#__theme`', "(theme='$theme' OR menu IN ($m)) AND lng='".LANGUAGE."'");
		
		for ($i=0; $i<count($menu); $i++) {
			$obj->theme = $theme;
			if ($menu[$i] == -1) continue;
			$obj->menu = $menu[$i];
			$obj->lng = LANGUAGE;
			$database->insert('`#__theme`', $obj);
		}
	}
	
	function delete() {
		global $database;
		$id = AppleGetParam('id', $_GET);
		$message = AppleMessage::getInstance();
		
		$database->setQuery("SELECT * FROM `#__theme` WHERE theme='$id'");
		$a = $database->loadObject();
		if ($a != null) {
			$message->add('error', __('You can not delete theme in use'));
			return false;
		}
		
		$fp = new AppleFileManager($this->directory.'/'.$id);
		if ($fp->delete()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		else {
			$message->add('error', __('unknown_error'));
			return false;
		}
	}
}

class positions {
	function save($list) {
		global $database;
		$position = AppleGetParam('pos', $_POST);
		$description = AppleGetParam('desc', $_POST);
		$message = AppleMessage::getInstance();
		
		$database->setQuery("SELECT DISTINCT(position) FROM `#__modules`");
		$rows = $database->loadObjectList();
		$count = count($rows);
		for ($i=0; $i<$count; $i++) {
			if ($position[$rows[$i]->position] == null) {
				$message->add('error', sprintf(__('You want to delete "%s" that used for some modules!'), $list[$rows[$i]->position]->position));
				return false;
			}
		}
		
		$count = count($position);
		$listCount = count($list);
		$id = 1;
		for ($i=1; $i<=$count; $i++) {
			if ($position[$i] == null) continue;
			if ($id <= $listCount) {
				$database->setQuery("UPDATE `#__theme_positions` SET `position`='".$position[$i]."' , `description`='".$description[$i]."' WHERE id=$id");
				$database->setQuery("UPDATE `#__modules` SET `position`='".$id."' WHERE position=$i");
			}
			else $database->setQuery("INSERT INTO `#__theme_positions` (id,position,description) VALUES ('$id','".$position[$i]."','".$description[$i]."')");
			$id++;
		}
		if ($id <= $listCount) $database->setQuery("DELETE FROM `#__theme_positions` WHERE id >= $id");
		
		if ($database->query()) {
			$message->add('success', __('Changes updated successfully'));
			return true;
		}
		$message->add('error', __('unknown_error'));
		return false;
	}
}
?>