<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class HTML {
	function listThemes($list, $user) {
		AppleSetPath(__('Themes Management'));
		$count = count($list);
		if ($count == 0) return;
		
		?>
		<form action="?" method="GET" onsubmit="return false;">
		<?php
		$action = array();
		$action[] = AppleHTML::makeOption(null, __('More Actions ....'));
		//$action[] = AppleHTML::makeOption('new', __('new'));
		if ($user == 'client') $action[] = AppleHTML::makeOption('default', __('Set as default'));
		if ($user == 'client') $action[] = AppleHTML::makeOption('assign', __('Assign'));
		$action[] = AppleHTML::makeOption('edit', __('Edit'));
		$action[] = AppleHTML::makeOption('delete', __('Delete'));
		
		$table = new table(null, null, 'width:900px; padding-bottom:5px;');
		$table->addTR();
		$table->addTD(AppleHTML::makeList($action, 'task', 'id="task"').' '.AppleHTML::makeButton(__('Go'), 'id="cancel" style="height:25px;" onclick="if (($(\'task\').value == \'delete\' && confirm(\''.__('Are you sure you want to delete selected item(s)?').'\')) || ($(\'task\').value == \'default\' && confirm(\''.__('Are you sure you want to set this theme as default?').'\')) || ($(\'task\').value != \'\' && $(\'task\').value != \'delete\' && $(\'task\').value != \'default\')) submitButton(this.form, $(\'task\').value)"'), 'text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').';');
		$table->show();
		
		$table = new table('list', 'list', 'width:600px;');
		$table->addTR();
		$table->addTH('#', 'width:5px;');
		$table->addTH('', 'width:5px;');
		$table->addTH(__('Name'), 'width:500px;');
		$table->addTH(__('Edit'), 'width:40px;');
		$table->addTH(__('Delete'), 'width:40px;');
		
		$r_l = settings::get('direction') == 'rtl' ? 'right' : 'left';
		
		$i = 0;
		foreach ($list as $item) {
			$i++;
			$table->addTR("id=\"tr_$i\"");
			$table->addTD(++$p);
			$table->addTD('<input type="radio" name="id" value="'.$item.'" id="'.$item.'">');
			$table->addTD($item, 'text-align:'.$r_l);
			$table->addTD(AppleHTML::editIcon($item));
			$table->addTD(AppleHTML::deleteIcon($item));
		}
		
		$table->show();
		
		?>
		<input type="hidden" name="com" value="themes" />
		<input type="hidden" name="user" value="<?php echo "$user"; ?>" />
		<input type="hidden" name="lng" value="<?php echo LANGUAGE; ?>" />
		</form>
		<?php
	}
	
	function editTheme($theme) {
		AppleSetPath(__('Edit Theme'));
		?>
		<center><form action="" method="post" dir="ltr">
			<div align="right" dir="rtl">
			<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
			<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
			<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=themes&user='.$theme->user.'&lng='.LANGUAGE.'\'"'); ?>
			</div>
			<br />
			<div class="vdiv bold"><?php echo $theme->id; ?></div>
			<textarea class="input" style="width:100%; height:400px;" name="theme"><?php echo $theme->content; ?></textarea><br>
			<br />
			<div class="vdiv bold"><?php echo $theme->id; ?> - CSS</div>
			<textarea class="input" style="width:100%; height:400px;" name="css"><?php echo $theme->css; ?></textarea><br>
			
			<div align="right" dir="rtl">
			<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
			<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
			<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=themes&user='.$theme->user.'&lng='.LANGUAGE.'\'"'); ?>
			</div>
		</form></center>
		<?php
	}
	
	function assign($obj) {
		AppleSetPath(__('Assign Theme'));
		?>
		<form action="" method="post">
			<div align="right" dir="<?php echo settings::get('direction'); ?>">
			<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
			<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
			<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=themes&user='.$obj->user.'&lng='.LANGUAGE.'\'"'); ?>
			</div><br />
			<div class="vdiv bold"><?php echo $obj->id; ?></div>
			<?php echo AppleHTML::makeList($obj->pages, 'pages[]', 'multiple="multiple" style="width:200px; height:300px;"', $obj->selected, 'id', 'title'); ?>
			<input type="hidden" name="id" value="<?php echo $obj->id; ?>"/>
		</form>
		<?php
	}
	
	function positions($list) {
		AppleSetPath(__('Modules Positions'));
		?>
		<style>
		able.admintemplates {width:100%; background:#fff; margin:0px; padding:0px; border:0;}
		.admintemplates td {border-bottom:1px solid #eee; padding:3px; color:#333;}
		.admintemplates th {margin:0px; padding:6px 4px 2px 4px;height:25px;background:#555;font-size:12px;color:#fff;}
		</style>
		<form action="" method="post">
		<div>
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=themes&lng='.LANGUAGE.'\'"'); ?>
		</div>
		<table class="admintemplates" cellpadding="1" cellspacing="1" border="0" align="center">
		<tr>
		<th>#</th>
		<th><?php _e('Position'); ?></th>
		<th><?php _e('Description'); ?></th>
		
		<th>#</th>
		<th><?php _e('Position'); ?></th>
		<th><?php _e('Description'); ?></th>
		</tr>
		<?php
		$id = 1;
		for ($i=0; $i<50; $i++) {
			if ($i%2 == 0) echo '<tr>';
			echo '<td>'.$id.' </td><td>'.AppleHTML::makeText('pos['.$id.']', $list[$id]->position, 'style="width:100px;" dir="ltr"').'</td>'.'<td>'.AppleHTML::makeText('desc['.$id.']', $list[$id]->description, 'style="width:300px;"').'</td>';
			if (($i+1)%2 == 0) echo '</tr>';
			$id++;
		}
		?>
		</table>
		<div>
		<?php echo AppleHTML::makeSubmitButton('save', 'value="'.__('Save').'"'); ?>
		<?php echo AppleHTML::makeResetButton('id="cancel"'); ?>
		<?php echo AppleHTML::makeButton(__('Cancel'), 'id="delete" onclick="document.location.href=\'?com=themes&lng='.LANGUAGE.'\'"'); ?>
		</div>
		</form>
		<?php
	}
}
?>