<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

define('ACCESS_ALLOW', true);

require_once(dirname(__FILE__).'/../settings.php');

$p = ApplePath::getInstance();
$p->removeAllItems();

$com = AppleGetParam('com', $_GET, 'main_page');
$task = AppleGetParam('task', $_GET);
$cid = intval(AppleGetParam('cid', $_GET, 0));
$uid = intval(AppleGetParam('uid', $_GET, 0));
$id = intval(AppleGetParam('id', $_GET, 0));
$page = intval(AppleGetParam('page', $_GET, 1));

$theme = ($com != 'login') ? AppleGetParam('load_theme', $_REQUEST, 'yes') : 'no';
if (AppleAjaxRequest()) $theme = 'no';

$AppleTheme = new AppleAdminTheme();
$user = AppleUser::getInstance();
if (($user->group != 1 && $com != 'login')) {
	$user->logout();
	// First check if the current HTTP-Request is an Ajax-Request
	if (AppleAjaxRequest()) {
		$message = AppleMessage::getInstance();
		$message->add('warning', __("You've been logged out of the system, so we're going to send you back to the log-in screen.").'<br /><a href="'.AppleMakeSef('?com=login').'">'.__("Click here if your browser does not automatically redirect you.").'</a>');
		die('<script language="javascript">
		if (!$("message")) {
			var div = document.createElement("div");
			div.className = "message";
			div.id = "message";
			div.style.position = "absolute";
			div.style.padding = "0";
			div.style.margin = "0";
			div.style.width = "100%";
			div.style.top = "0";
			div.style.left = "0";
			document.body.appendChild(div);
		}
		$("message").innerHTML = "'.addslashes(AppleShowMessage()).'";
		setTimeout("document.location.href=\"'.AppleMakeSef('?com=login').'\"", 7000);
		</script>');
	}
	AppleRedirect('?com=login');
}

if ($theme == 'yes') {
	if ($user->id == 0 && $com != 'login'){
		AppleRedirect(AppleMakeSef('?com=login'));
	}
	$html = $AppleTheme->getTheme();
	$AppleTheme->execute($html);
}
elseif ($theme == 'no') {
	if ($user->id == 0 && $com != 'login') return null;
	$AppleTheme->execute(null);
}
?>