<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class content {
	
	function listContents($parts, $cid=0) {
		global $database, $com, $section;
		$now = AppleGetNow('Y-m-d H:i:s');
		$where = null;
		if ($section == 'categories') $where = "cid='$cid' AND ";
		$where .= "lng='".LANGUAGE."' AND ((start<'".$now."') AND (end>'".$now."' OR end='0000-00-00 00:00:00')) AND published='1'";
		
		$database->setQuery("SELECT COUNT(*) as count FROM `#__content` WHERE $where");
		$count = $database->loadObject();
		$count = $count->count;
		
		$pageNav = new ApplePageNav($count, 10);
		
		$database->setQuery("SELECT * FROM `#__content` WHERE $where ORDER BY id DESC $pageNav->sql_limit");
		$list = $database->loadObjectList();
		
		HTML::listContent($list, $pageNav);
		
		// Set $_GET, $_SERVER['QUERY_STRING'], ...
		if ($cid > 0) {
			$parts[0] = 'content';
			$parts[1] = 'section';
			$parts[2] = 'categories';
			$parts[3] = 'id';
			$parts[4] = $cid;
			$parts[5] = 'lng';
			$parts[6] = LANGUAGE;
			AppleSefReverse($parts);
		}
	}
	
	function view($parts) {
		global $database;
		$id = intval(AppleGetParam("id", $_GET, 0));
		if ($id == 0) {
			$where = "`unique_name`='$parts[0]'";
		}
		else $where = "id=$id";
		$where .= " AND lng='".LANGUAGE."'";
		
		$now = AppleGetNow('Y-m-d H:i:s');
		
		$database->setQuery("SELECT * FROM #__content WHERE $where AND ((start<'".$now."' OR start='0000-00-00 00:00:00') AND (end>'".$now."' OR end='0000-00-00 00:00:00')) AND published='1'");
		$content = $database->loadObject();
		
		if (!$content) {
			include(Apple_root_path.'/page404.php');
			return ;
		}
		
		// Set $_GET, $_SERVER['QUERY_STRING'], ...
		if ($id == 0) {
			$parts[0] = 'content';
			$parts[1] = 'id';
			$parts[2] = $content->id;
			AppleSefReverse($parts);
		}
		
		$database->setQuery("UPDATE `#__content` SET hits=hits+1 WHERE $where ");
		$database->query();
		
		AppleSetTitle($content->title);
		AppleSetPath(__('Content'), '?com=content&lng='.LANGUAGE);
		$this->createPath($content->cid);
		AppleSetPath($content->title);
		
		HTML::view($content);
	}
	
	function printContent() {
		global $database;
		$id = intval(AppleGetParam("id", $_GET, 1));
		$now = AppleGetNow('Y-m-d H:i:s');
		
		$database->setQuery("SELECT * FROM #__content WHERE id='$id' AND ((start<'".$now."' OR start='0000-00-00 00:00:00') AND (end>'".$now."' OR end='0000-00-00 00:00:00')) AND published='1'");
		$content = $database->loadObject();
		
		if (!$content->print_status) return ;
		header('Content-Type: text/html;charset=UTF-8', true);
		HTML::printContent($content);
	}
	
	function createPath($cid) {
		global $database, $section;
		
		if ($section == 'categories') {
			if ($cid > 0)
				AppleSetPath(__('Categories'), '?com=content&section=categories&lng='.LANGUAGE);
			else {
				AppleSetPath(__('Categories'));
				return;
			}
		}
		
		$i = 0;
		$database->setQuery("SELECT id,name,parent FROM `#__categories` WHERE id='$cid'");
		$cat = $database->loadObject();
		$item['title'][$i] = $cat->name;
		$item['url'][$i] = (($cat->id!=$cid && $section!='view') || ($cid!=0 && $section == 'view')) ? '?com=content&section=categories&id='.$cat->id.'&lng='.LANGUAGE : null;
		$i++;
		
		while ($cat->parent > 0) {
			$database->setQuery("SELECT id,name,parent,published FROM `#__categories` WHERE id='$cat->parent'");
			$cat = $database->loadObject();
			if ($cat->published == 0) continue;
			$item['title'][$i] = $cat->name;
			$item['url'][$i] = (($cat->id!=$cid && $section!='view') || ($cid!=0 && $section == 'view')) ? '?com=content&section=categories&id='.$cat->id.'&lng='.LANGUAGE : null;
			$i++;
		}
		while ($i >= 0) {
			AppleSetPath($item['title'][$i], $item['url'][$i]);
			$i--;
		}
	}
	
	function categories($parts) {
		global $database, $com, $section;
		$id = intval(AppleGetParam("id", $_GET, 0));
		$cid = intval(AppleGetParam("cid", $_GET, 0));
		if ($id == 0 && $cid > 0) $id = $cid;
		
		if ($id == 0) {
			$where = "`unique_name`='$parts[2]'";
		}
		else $where = "id=$id";
		$where .= " AND lng='".LANGUAGE."'";
		
		$database->setQuery("SELECT * FROM `#__categories` WHERE $where");
		$obj = $database->loadObject();
		$id = $obj->id;
		
		AppleSetPath(__('Content'), '?com=content&lng='.LANGUAGE);
		$this->createPath($id);
		AppleSetTitle(__('List Of Contents'));
		
		$database->setQuery("SELECT * FROM `#__categories` WHERE ".($id > 0 ? "parent=$id AND id!=$id AND" : '')." published=1 AND lng='".LANGUAGE."'");
		$list = $database->loadObjectList();
		
		if (!empty($list))
			HTML::categories($list);
		
		if ($obj->published == 0) {
			if (empty($list)) include(Apple_root_path.'/page404.php');
			return ;
		}
		
		
		$this->listContents($parts, $id);
	}
	
	function getPermaLink($part) {
		$return = null;
		
		if (($part['section'] == 'view' || $part['section'] == '') && $part['id'] > 0 ) {
			global $database;
			$database->setQuery("SELECT `unique_name` FROM `#__content` WHERE id=$part[id]");
			$ob = $database->loadObject();
			if (!empty($ob->unique_name)) {
				$return = $ob->unique_name;
				foreach ($part as $k => $v) {
					if ($k != 'com' && $k != 'section' && $k != 'id') $return .= "/$k/$v";
				}
			}
		}
		elseif (($part['section'] == 'categories') && $part['id'] > 0 ) {
			global $database;
			$database->setQuery("SELECT `unique_name` FROM `#__categories` WHERE id=$part[id]");
			$ob = $database->loadObject();
			if (!empty($ob->unique_name)) {
				$return = 'content/cat/'.$ob->unique_name;
				foreach ($part as $k => $v) {
					if ($k != 'com' && $k != 'section' && $k != 'id') $return .= "/$k/$v";
				}
			}
		}
		if ($return == null) {
			$return = (empty($part['com']) ? settings::get('default_component') : $part['com']);
			foreach ($part as $k => $v) {
				if ($k != 'com') $return .= "/$k/$v";
			}
		}
		return $return;
	}
}
?>