<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class HTML {
	
	function categories($list) {
		echo '<div class="content">
		<fieldset class="categories">
		<legend>&nbsp;'.__('Categories').'&nbsp;</legend>
		<table width="100%" cellpadding="1" cellspacing="1" border="0" align="center">';
		for ($i=0; $i<count($list); $i++) {
			if ($i%3 == 0) echo '<tr>';
			echo '<td width="33%"><a href="'.AppleMakeSef('?com=content&section=categories&id='.$list[$i]->id.'&lng='.LANGUAGE).'">'.$list[$i]->name.'</a></td>';
			if (($i+1)%3 == 0) echo '</tr>';
		}
		echo '</table></fieldset>
		</div>';
	}
	
	function listContent($list, $pageNav) {
		if (empty($list)) return ;
		foreach ($list as $item) {
			if ($item->id == 0) break;
			AppleSetKeywords($item->keywords);
			if (strstr($item->text, '<!-- pagebreak -->')) {
				$text = explode('<!-- pagebreak -->', $item->text);
				$text = $text[0].' <a href="'.AppleMakeSef('?com=content&id='.$item->id.'&lng='.LANGUAGE).'">'.__('More').' &raquo;</a>';
			}
			else $text = $item->text;
			echo '<div class="content">
			<div class="header">
			<div class="title"><a href="'.AppleMakeSef('?com=content&id='.$item->id.'&lng='.LANGUAGE).'" style="font-weight:bold;">'.$item->title.'</a></div>
			<div class="date">'.($item->date_status ? AppleDate($item->start, 'Y-m-d', 0, 0) : '').'</div>
			</div>
			<div class="body">
				'.$text.'
			</div>
			<div class="clear">&nbsp;</div>
			<hr class="hr" size="1" />
			</div>';
		}
		if ($pageNav != null) echo $pageNav->writePages();
	}
	
	function view($content) {
		echo '<div class="content">
				<div class="header">
					<div class="icons">';
		if ($content->print_status) echo '<a href="javascript:void(0);" onclick="window.open(\''.AppleMakeSef('?com=content&section=print&id='.$content->id.'&load_theme=no').'\', \'_blank\', \'width=900,height=600,scrollbars=yes,status=yes,resizable=no\');" style="text-decoration:none;"><img src="images/print.png" title="Printable" style="border:0;"> </a> ';
		if ($content->email_status) echo '<a href="'.AppleMakeSef('?com=content&section=s2f&id='.$content->id.'&load_theme=no').'" style="text-decoration:none;"><img src="images/email.png" title="Send To Friends" style="border:0;"></a>';
		echo '</div>
					<div class="title">'.$content->title.'</div>
					<div class="date">'.($content->date_status ? AppleDate($content->start, 'Y-m-d', 0, 0) : '').'</div>
				</div>
				
				<div class="body">
					'.$content->text.'
					<div class="clearer">&nbsp;</div>
				</div>
				
				<div class="metadata">
				
				</div>
			</div>';
	}
	
	function printContent($content) {
		echo '<div style="border:1px solid #ccc; text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').'; directoin:rtl;">
			<div style="padding:10px; font-weight:bold;">'.settings::get('title').'</div>
			<div style="padding:10px; font-weight:bold;">'.$content->title.'</div>
			<div style="padding:10px; padding-top:0; font-weight:none;">
				'.$content->text.'<br><br> '.AppleDate($content->date, 'Y-m-d H:i:s').'</div>
			<div style="padding:10px; padding-top:0; font-size:9pt; font-weight:none; text-align:'.(settings::get('direction') == 'rtl' ? 'right' : 'left').'; direction:ltr;">
				'.AppleMakeSef(settings::get('url').'/?com=content&id='.$content->id.'&lng='.LANGUAGE).'<br><center><button class="btn" onclick="print();">'.__('Print').'</button></center>
			</div>
		</div>';
	}
}
?>