<?php
/**
 * @package Apple
 * @author Parsisoft Inc.
 * @copyright Parsisoft Inc.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class gallery {
	static public $settings;
	
	function __construct() {
		global $database;
		$database->setQuery("SELECT * FROM `#__gallery_settings` WHERE lng='".LANGUAGE."'");
		$list = $database->loadRowList('key', 'assoc');
		if (!empty($list)) {
			foreach ($list as $row) {
				self::$settings[$row['key']] = $row['value'];
			}
		}
	}
	
	function galleries($id, $N=25) {
		global $database;
		$page = intval(AppleGetParam("page", $_GET, 1));
		if ($id == 0) AppleSetPath(__('Gallery'));
		else AppleSetPath(__('Gallery'), '?com=gallery&lng='.LANGUAGE);
		$this->createPath($id);
		$database->setQuery("SELECT COUNT(*) as count FROM `#__gallery_galleries`
		WHERE parent=$id AND published=1 AND lng='".LANGUAGE."'");
		$count = $database->loadObject();
		$count = $count->count;
		
		$pageNav = new ApplePageNav($count, $N);
		
		$database->setQuery("SELECT a.*, COUNT(b.id) AS count, c.image AS image FROM `#__gallery_galleries` AS a
		INNER JOIN `#__gallery_images` AS b ON a.id=b.cid
		LEFT JOIN `#__gallery_images` AS c ON c.id=(SELECT id FROM `#__gallery_images` WHERE cid=a.id LIMIT 1)
		WHERE a.parent=$id AND a.published=1 AND a.lng='".LANGUAGE."'
		GROUP BY a.id
		ORDER BY a.ordering
		$pageNav->sql_limit");
		$list = $database->loadObjectList();
		
		if (empty($list)) return ;
		HTML::galleries($list, $pageNav);
	}
	
	function createPath($id) {
		global $database, $task;
		if ($id == 0) {
			return ;
		}
		
		$path = array();
		
		$database->setQuery("SELECT id, name, parent FROM `#__gallery_galleries`
		WHERE id=$id AND published=1 AND lng='".LANGUAGE."'");
		$gallery = $database->loadObject();
		$g = $gallery;
		
		while ($gallery->parent > 0) {
			$database->setQuery("SELECT id, name, parent FROM `#__gallery_galleries`
			WHERE id=$gallery->parent AND published=1 AND lng='".LANGUAGE."'");
			$gallery = $database->loadObject();
			$path[] = $gallery;
		}
		
		if (!empty($path)) {
			array_reverse($path);
			reset($path);
			foreach ($path as $item) {
				AppleSetPath($item->name, '?com=gallery&id='.$item->id.'&lng='.LANGUAGE);
			}
		}
		AppleSetPath($g->name, ($task == 'list') ? '' : '?com=gallery&id='.$g->id.'&lng='.LANGUAGE);
		unset($path);
	}
	
	function images($id, $N=12) {
		global $database;
		$page = intval(AppleGetParam("page", $_GET, 1));
		$database->setQuery("SELECT COUNT(*) AS count FROM `#__gallery_images`
		WHERE cid=$id AND published=1");
		
		$count = $database->loadObject();
		$count = $count->count;
		$pageNav = new ApplePageNav($count, $N);
		
		$database->setQuery("SELECT * FROM `#__gallery_images`
		WHERE cid=$id AND published=1
		ORDER BY ordering
		$pageNav->sql_limit");
		$images = $database->loadObjectList();
		if (empty($images)) return ;
		HTML::images($images, $pageNav);
	}
	
	function view($image) {
		global $database;
		$database->setQuery("SELECT * FROM `#__gallery_images` WHERE image='$image' AND published=1");
		$image = $database->loadObject();
		
		if ($image == null) return ;
		if ($image->title != null) $image->title = $image->image;
		
		AppleSetPath(__('Gallery'), '?com=gallery&lng='.LANGUAGE);
		$this->createPath($image->cid);
		AppleSetPath($image->title);
		
		$image->hits++;
		$database->update('`#__gallery_images`', $image, 'image=\''.$image->image.'\'');
		
		$database->setQuery("SELECT id, image FROM `#__gallery_images`
		WHERE cid=$image->cid");
		$list = $database->loadObjectList();
		
		for ($i=0; $i<count($list); $i++) {
			if ($list[$i]->id == $image->id) {
				$image->previous = $list[$i-1]->image;
				$image->next = $list[$i+1]->image;
			}
		}
		
		HTML::view($image);
	}
	
	function download($image) {
		header('Content-Description: File Transfer');
		header('Content-Type: application/force-download');
		header('Content-Length: ' . filesize("uploads/gallery/$image"));
		header('Content-Disposition: attachment; filename='.$image.'');
		header('Cache-Control: cache, must-revalidate');
		header('Pragma: public');
		$file = file_get_contents("uploads/gallery/$image");
		echo $file;
	}
	
	/**
	 * Gets and shows image from gallery directory
	 *
	 */
	function image() {
		$image = AppleGetParam('image', $_GET);
		if ($image == null) $image = 'none.gif';
		$width = intval(AppleGetParam('width', $_GET, 100));
		$height = intval(AppleGetParam('height', $_GET, 100));
		AppleImageResize("uploads/gallery/$image", $width, $height);
	}
}
?>