<?php
/**
 * @package Apple
 * @author Parsisoft Inc.
 * @copyright Parsisoft Inc.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class HTML {
	function galleries($list, $pageNav) {
		echo '<div class="content">
			<div class="content_body">
			<table class="list" cellpadding="2" cellspacing="2" border="0">';
		
		@reset($list);
		foreach ($list as $gallery) {
			echo '<tr>
			<td style="padding:1px; border:1px solid #ccc;"><a href="'.AppleMakeSef('?com=gallery&id='.$gallery->id.'&lng='.LANGUAGE).'"><img src="'.AppleMakeSef('?com=gallery&task=image&image='.$gallery->image.'&load_theme=no').'" style="width:100px; height:100px;" title="'.__('Open Gallery', 'gallery').'"></a></td>
			<td dir="'.settings::get('direction').'" valign="top"><a href="'.AppleMakeSef('?com=gallery&id='.$gallery->id.'&lng='.LANGUAGE).'">'.$gallery->name.'</a>
			<br /><span dir="'.settings::get('direction').'" class="description">('.($gallery->count > 1 ? sprintf("%d Images", $gallery->count) : sprintf("%d Image", $gallery->count)).')</span>
			<br /><br /><span dir="'.settings::get('direction').'" class="description">'.$gallery->txt.'</span>
			</td>
			</tr>';
		}
		
		echo '</table>
		'.$pageNav->writePages().'
		</div>
		</div>';
	}
	
	function images($list, $pageNav) {
		echo '<div class="content">
			<div class="content_body">
			<table class="list" cellpadding="2" cellspacing="2" border="0">';
		@reset($list);
		$i = 0;
		foreach ($list as $image) {
			if ($i%gallery::$settings['count_images_per_row'] == 0) echo '<tr>';
			echo '<td style="padding:1px; width:'.(100/gallery::$settings['count_images_per_row']).'%"><a href="'.AppleMakeSef('?com=gallery&image='.$image->image.'&lng='.LANGUAGE).'"><img src="'.AppleMakeSef('?com=gallery&task=image&image='.$image->image.'&load_theme=no&width=100&height=100').'" style="width:100px; height:100px; padding:1px; border:1px solid #ccc;" alt="'.$image->title.'" title="'.$image->title.'"></a></td>';
			if ((++$i)%gallery::$settings['count_images_per_row'] == 0) echo '</tr>';
		}
		
		echo '</table>
		'.$pageNav->writePages().'
		</div>
		</div>';
	}
	
	function view($image) {
		echo '<div class="content">
		<div class="header"><div class="title">'.$image->title.'</div></div>
		<div class="body">
		<div class="right" dir="rtl">';
		if ($image->next != null) echo '<a href="'.AppleMakeSef('?com=gallery&image='.$image->next).'"><img src="components/gallery/images/next.png" style="vertical-align:middle;"> '.__('Next', 'gallery').'</a>';
		else echo '<img src="components/gallery/images/next-g.png" style="vertical-align:middle;"> '.__('Next', 'gallery');
		echo '</div><div class="left" dir="ltr">';
		if ($image->previous != null) echo '<a href="'.AppleMakeSef('?com=gallery&image='.$image->previous).'"><img src="components/gallery/images/previous.png" style="vertical-align:middle;"> '.__('Previous', 'gallery').'</a>';
		else echo '<img src="components/gallery/images/previous-g.png" style="vertical-align:middle;"> '.__('Previous', 'gallery');
		echo '</div><div class="clear"></div><br />';
		list($width, $height) = @getimagesize("uploads/gallery/$image->image");
		if ($width > gallery::$settings['max_width']) $width = gallery::$settings['max_width'];
		if ($height > gallery::$settings['max_height']) $height = gallery::$settings['max_height'];
		echo '<div style="text-align:center; margin-bottom:10px;">
			<img src="'.AppleMakeSef('?com=gallery&task=image&image='.$image->image.'&width='.$width.'&height='.$height.'&load_theme=no').'" style="width:'.$width.'px; height:'.$height.'px; padding:1px; border:1px solid #ccc;" alt="'.$image->title.'" title="'.$image->title.'">
			<br /><br /><a href="'.AppleMakeSef('?com=gallery&task=download&image='.$image->image.'&load_theme=no').'"><img src="components/gallery/images/download.gif" alt="'.__('Download', 'gallery').'" title="'.__('Download', 'gallery').'"></a>
		</div>';
		
		$table = new table('gallery');
		$table->addTR();
		$table->addTH($image->title, null, 'colspan="2"');
		
		if (gallery::$settings['show_txt']) {
			$table->addTR();
			$table->addTD(__('description', 'gallery'), 'width:150px;');
			$table->addTD($image->txt);
		}
		if (gallery::$settings['show_date']) {
			$table->addTR();
			$table->addTD(__('Date', 'gallery'));
			$table->addTD(AppleDate($image->date, 'd F Y'));
		}
		if (gallery::$settings['show_hits']) {
			$table->addTR();
			$table->addTD(__('Hits', 'gallery'));
			$table->addTD($image->hits);
		}
		if (gallery::$settings['show_dimensions']) {
			list($width, $height) = @getimagesize("uploads/gallery/$image->image");
			$table->addTR();
			$table->addTD(__('Dimensions', 'gallery'));
			$table->addTD($width."px x ".$height."px", 'direction:ltr;');
		}
		if (gallery::$settings['show_size']) {
			$size = @filesize("uploads/gallery/$image->image");
			$table->addTR();
			$table->addTD(__('Size', 'gallery'));
			$table->addTD(number_format($size / 1024, 2, ",", ".").' '.__('KB', 'gallery'));
		}
		
		$table->show();
		echo '<br /><div class="right" dir="rtl">';
		if ($image->next != null) echo '<a href="'.AppleMakeSef('?com=gallery&image='.$image->next).'"><img src="components/gallery/images/next.png" style="vertical-align:middle;"> '.__('Next', 'gallery').'</a>';
		else echo '<img src="components/gallery/images/next-g.png" style="vertical-align:middle;"> '.__('Next', 'gallery');
		echo '</div><div class="left" dir="ltr">';
		if ($image->previous != null) echo '<a href="'.AppleMakeSef('?com=gallery&image='.$image->previous).'"><img src="components/gallery/images/previous.png" style="vertical-align:middle;"> '.__('Previous', 'gallery').'</a>';
		else echo '<img src="components/gallery/images/previous-g.png" style="vertical-align:middle;"> '.__('Previous', 'gallery');
		echo '</div><div class="clear"></div>
		</div>
		</div>';
	}
}
?>