<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

define('ACCESS_ALLOW', true);
define('INSTALLING', true);

require_once(dirname(__FILE__).'/../settings.php');

$step = intval(AppleGetParam('step', $_GET, 1));

if (file_exists(Apple_root_path.'/configuration.php') && $step != 2) {
	AppleDie('<h1>Configuration file exists</h1><p>A <code>configuration.php</code> file already exists.<br />To create a new configuration file using the Wizard, remove the current configuration file and then refresh this page. You can modify this file manually, open it in a text editor, fill in your information, and save it as <code>configuration.php</code>. Are you trying to <a href="?step=2">install Apple</a>?</p>');
}
elseif (file_exists(Apple_root_path.'/configuration.php')) {
	require_once(Apple_root_path.'/configuration.php');
	$database = db::getInstance();
	mysql_set_charset('utf8');
	if (AppleInstalled()) {
		AppleDie('<h1>Already Installed</h1><p>You appear to have already installed Apple. To reinstall please clear your old database tables first.</p>');
	}
}
else $step = 1;

$email = AppleGetParam('email', $_POST);
if (!isset($email)) showFormInstallation();
else {
	if (!AppleEmailValidity($email)) AppleDie('<h1>ERROR</h1><p>You must enter a valid email address. it must be look like <code>kernel@applecms.org</code></p><p><a href="index.php?step='.$step.'" class="button">&laquo; Back</a></p>');
	
	$h1 = '';
	if ($step == 1) {
		$host = AppleGetParam('db_host', $_POST);
		$user = AppleGetParam('db_username', $_POST);
		$password = AppleGetParam('db_password', $_POST);
		$name = AppleGetParam('db_name', $_POST);
		$prefix = AppleGetParam('db_prefix', $_POST);
		
		$database = new database($host, $user, $password, $name, $prefix);
		mysql_set_charset('utf8');
		$x = '<?php
define(\'db_host\',\''.$host.'\');
define(\'db_user\',\''.$user.'\');
define(\'db_password\',\''.$password.'\');
define(\'db_name\',\''.$name.'\');
define(\'db_prefix\',\''.$prefix.'\');
define(DEFAULT_LANGUAGE, \'fa\');
?>';
		if ($fp = @fopen(Apple_root_path.'/configuration.php', 'w')) {
			fputs($fp, $x);
			fclose($fp);
			chmod(Apple_root_path.'/configuration.php', 0666);
			$msg = '<li>Configuartion file created successfully.</li>';
		}
		else {
			$h1 = 'Apple installed with some errors!';
			$msg = '<li style="color:#e03838;">Sorry, Apple doesn\'t have the permission to create the configuration file. You can change the permissions on your Apple directory and refresh this page or create your <code>configuration.php</code> manually, open it in a text editor, fill in these code, and save it</li>
			<div class="code">'.nl2br(htmlspecialchars($x)).'</div>';
		}
	}
	
	if (!AppleInstalled()) {
		if (!file_exists(Apple_root_path.'/installation/install.sql')) {
			if ($h1 == '') $msg .= '<li style="color:#e03838;">Apple needs <code>install.sql</code> file to start installing. You may find help at the <a href="http://forums.applecms.org" target="_blank">Apple Forums</a>.</li>';
			else $msg = '<li style="color:#e03838;">Apple needs <code>install.sql</code> file to start installing. You may find help at the <a href="http://forums.applecms.org" target="_blank">Apple Forums</a>.</li>';
			$h1 = 'Installation Failed!';
		}
		else {
			if (!$database->importSql(Apple_root_path.'/installation/install.sql')) {
				if ($h1 == '') $msg .= '<li style="color:#e03838;">Sorry, Installation does not successfully complete. You may find help at the <a href="http://forums.applecms.org" target="_blank">Apple Forums</a>.</li>';
				else $msg = '<li style="color:#e03838;">Sorry, Installation does not successfully complete. You may find help at the <a href="http://forums.applecms.org" target="_blank">Apple Forums</a>.</li>'.$msg;
				$h1 = 'Installation Failed!';
			}
			else {
				$password = AppleGeneratePassword();
				$database->setQuery("UPDATE `#__users` SET email='$email', password='".md5($password)."', reg_date='".AppleGetNow('Y-m-d')."'");
				
				$url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'];
				$url = explode('installation', $url);
				$url = $url[0];
				// Remove slashes after the url
				while (ereg('/$', $url)) {
					$url= ereg_replace('/$', '', $url);
				}
				$database->setQuery("UPDATE `#__settings` SET `value`='$url' WHERE `key`='url'");
				$database->query();
				if ($h1 == '') {
					$h1 = 'Success';
					$msg .= '<li>Congratulations! Installation successfully complete.</li>';
				}
				else {
					$msg = '<li>Congratulations! Installation successfully complete.</li>'.$msg;
				}
				$msg .= '<br /><div class="code"><b>Your Login Information</b><br /><b>Username:</b> admin<br /><b>Password:</b> '.$password.'</div>';
			}
		}
	}
	else {
		if ($h1 == '') {
			$h1 = 'Already Installed';
			$msg .= '<li>You appear to have already installed Apple. To reinstall please clear your old database tables first.</li>';
		}
		else $msg = '<li>You appear to have already installed Apple. To reinstall please clear your old database tables first.</li>'.$msg;
	}
	AppleDie('<h1>'.$h1.'</h1><p><ul>'.$msg.'</ul></p>', $h1);
}



function showFormInstallation() {
	$step = intval(AppleGetParam('step', $_GET, 1));
	?>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Installation</title>
<link rel="shortcut icon" href="../images/favicon.png" type="image/x-icon">
<link rel="stylesheet" type="text/css" href="../kernel/css/style.css">
<script type="text/javascript" src="../kernel/js/prototype/prototype.js"></script>
<script type="text/javascript" src="../kernel/js/apple.js"></script>
<link rel="stylesheet" type="text/css" href="js/messages/messages.css" />
<script type="text/javascript">
function validate(form) {
	if (form.db_name.value == '') {
		error.inlineMsg('db_name', 'You must enter your database\'s name.', 2);
		return false;
	}
	
	if (form.db_username.value == '') {
		error.inlineMsg('db_username', 'You must enter your MySQL username.', 2);
		return false;
	}
	
	if (form.db_host.value == '') {
		error.inlineMsg('db_host', 'You must enter your host name.', 2);
		return false;
	}
	
	if (!emailValidity(form.email.value)) {
		error.inlineMsg('email', 'You must enter a valid email address.', 2);
		return false;
	}
	
	return true;
}
</script>
</head>
<body>
<div class="logo"></div>
<div>
	<h1>Welcome</h1>
	<p>Welcome to the One step Apple installation process!</p>

	<p>Just fill in the information below. Don't worry, you can change these settings later.</p>
	<form action="index.php?step=<?php echo $step; ?>" method="POST" <?php if ($step == 1) echo 'onsubmit="return validate(this)"'; ?>>
	<table cellpadding="0" cellspacing="0" width="100%" brder="0">
	<?php if ($step == 1) : ?>
	<tr>
		<th width="130">Database Name</th><td><input type="text" name="db_name" id="db_name" /></td><td>The name of the database you want to run Apple in.</td>
	</tr>
	<tr>

		<th width="130">User Name</th><td><input type="text" name="db_username" id="db_username" /></td><td>Your MySQL username</td>
	</tr>
	<tr>
		<th width="130">Password</th><td><input type="password" name="db_password" id="db_password" /></td><td>...and MySQL password.</td>
	</tr>
	<tr>
		<th width="130">Database Host</th><td><input type="text" name="db_host" id="db_host" value="localhost" /></td><td>Always you won't need to change this value.</td>

	</tr>
	<tr>
		<th width="130">Table Prefix</th><td><input type="text" name="db_prefix" id="db_prefix" value="apple_" /></td><td>If you want to run multiple Apple installations in a single database, change this.</td>
	</tr>
	<?php endif; ?>
	<tr>
		<th width="130">Your E-mail</th><td><input type="text" name="email" id="email" /></td><td>Enter your e-mail address, Double-check your email address before continuing.</td>
	</tr>

	<tr>
		<td style="background:inherit;" colspan="3"><input type="submit" class="button" style="width:100%;" value="Install Apple" /></td>
	</tr>
	</table>
	</form>
</div>
</body>
</html>
	<?php
}
?>