

--
-- Table structure for table `apple_banner`
--

CREATE TABLE IF NOT EXISTS `apple_banner` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `user` bigint(20) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `total` int(11) default '0',
  `view` int(11) default '0',
  `clicks` int(11) default '0',
  `url` varchar(100) NOT NULL,
  `image` varchar(100) NOT NULL,
  `date` datetime NOT NULL,
  `start` datetime NOT NULL,
  `published` tinyint(1) default '1',
  `ordering` bigint(20) default '1',
  `lng` varchar(10) default 'fa',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `apple_banner`
--


-- --------------------------------------------------------

--
-- Table structure for table `apple_banner_users`
--

CREATE TABLE IF NOT EXISTS `apple_banner_users` (
  `id` bigint(20) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `email` varchar(100) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `apple_banner_users`
--


-- --------------------------------------------------------

--
-- Table structure for table `apple_categories`
--

CREATE TABLE IF NOT EXISTS `apple_categories` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `parent` bigint(20) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `unique_name` varchar(255) default NULL,
  `published` tinyint(1) default '1',
  `ordering` bigint(20) default '1',
  `lng` varchar(10) default 'fa',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT AUTO_INCREMENT=1 ;

--
-- Dumping data for table `apple_categories`
--


-- --------------------------------------------------------

--
-- Table structure for table `apple_components`
--

CREATE TABLE IF NOT EXISTS `apple_components` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(40) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC AUTO_INCREMENT=4 ;

--
-- Dumping data for table `apple_components`
--

INSERT INTO `apple_components` (`id`, `name`) VALUES
(1, 'home'),
(2, 'content'),
(3, 'contact');

-- --------------------------------------------------------

--
-- Table structure for table `apple_contact`
--

CREATE TABLE IF NOT EXISTS `apple_contact` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `name` text NOT NULL,
  `subject` varchar(100) NOT NULL,
  `email` varchar(100) default NULL,
  `message` longtext NOT NULL,
  `date` datetime NOT NULL,
  `status` varchar(10) default 'unread',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT AUTO_INCREMENT=1 ;

--
-- Dumping data for table `apple_contact`
--


-- --------------------------------------------------------

--
-- Table structure for table `apple_content`
--

CREATE TABLE IF NOT EXISTS `apple_content` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `cid` bigint(20) unsigned default '0',
  `author` bigint(20) unsigned NOT NULL,
  `unique_name` varchar(255) default NULL,
  `title` text NOT NULL,
  `keywords` text,
  `description` text,
  `text` longtext NOT NULL,
  `date` datetime NOT NULL,
  `start` datetime default '0000-00-00 00:00:00',
  `end` datetime default '0000-00-00 00:00:00',
  `modified` datetime NOT NULL,
  `modified_by` bigint(20) unsigned default '0',
  `date_status` tinyint(1) default '1',
  `comment_status` tinyint(1) default '1',
  `print_status` tinyint(1) default '1',
  `email_status` tinyint(1) default '1',
  `hits` bigint(20) default '0',
  `published` tinyint(1) default '1',
  `ordering` bigint(20) default '1',
  `access` int(10) unsigned default '0',
  `lng` varchar(10) default 'fa',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC AUTO_INCREMENT=1 ;

--
-- Dumping data for table `apple_content`
--


-- --------------------------------------------------------

--
-- Table structure for table `apple_home`
--

CREATE TABLE IF NOT EXISTS `apple_home` (
  `title` varchar(255) NOT NULL,
  `text` longtext NOT NULL,
  `lng` varchar(10) NOT NULL default 'fa',
  PRIMARY KEY  (`lng`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `apple_home`
--

INSERT INTO `apple_home` (`title`, `text`, `lng`) VALUES
('سیستم مدیریت محتوای اپل', '<p style="text-align: right;"><img style="float: left;" src="uploads/images/1.0beta.gif" alt="Apple 1.0dev" />اپل، یک سیستم مدیریت محتوای کامپوننت بیس (Component Base) میباشد بدین معنی که به شما این امکان را میدهد تا با نصب کامپوننتها و ماژولهای مورد نیاز خود، وب سایت خود را راه اندازی و مدیریت کنید.</p>\r\n<p style="text-align: right;">&nbsp;</p>\r\n<p style="text-align: right;">اپل با زبان برنامه نویسی محبوب و قدرتمند <a href="http://www.php.net/" target="_blank">PHP</a> نوشته شده و از پایگاه داده <a href="http://www.mysql.com/" target="_blank">MySQL</a> استفاده می کند. اپل یک نرم افزار <a href="http://fa.wikipedia.org/wiki/نرم افزار_آزاد" target="_blank">بازمتن</a> (Open Source) بوده و <span style="color: #63839b;"><a style="color: #4678b8;" href="license.txt" target="_blank">تحت لیسانس GNU/GPL 2</a></span> منتشر میشود. بر اساس این اجازه&zwnj;نامه تمامی موارد استفاده از اپل کاملًا رایگان بوده و میتوانید آنرا براساس نیاز خود تغییر داده و بعنوان سکویی برای پروژه های خود به کار گیرید.</p>\r\n<p style="text-align: right;">&nbsp;</p>\r\n<p style="text-align: right;">اپل علاوه بر داشتن خصوصیات کامل یک CMS برای کاربران عادی، خصوصیات کامل یک CMF (فریم&zwnj;ورک مدیریت محتوا) را نیز درخود دارد. بنابراین اگر سررشته&zwnj;ای از برنامه نویسی با زبان PHP دارید میتوانید به راحتی کامپوننتها و ماژولهای مورد نیاز خود را بسازید بدون اینکه نیازی به دستکاری هسته سیستم داشته باشید :)</p>', 'fa');

-- --------------------------------------------------------

--
-- Table structure for table `apple_languages`
--

CREATE TABLE IF NOT EXISTS `apple_languages` (
  `lng` varchar(10) NOT NULL default 'fa',
  `name` varchar(255) NOT NULL default 'پارسی',
  PRIMARY KEY  (`lng`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `apple_languages`
--

INSERT INTO `apple_languages` (`lng`, `name`) VALUES
('fa', 'فارسی');

-- --------------------------------------------------------

--
-- Table structure for table `apple_menu`
--

CREATE TABLE IF NOT EXISTS `apple_menu` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `published` tinyint(1) default '1',
  `ordering` bigint(20) default '1',
  `lng` varchar(10) default 'fa',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT AUTO_INCREMENT=4 ;

--
-- Dumping data for table `apple_menu`
--

INSERT INTO `apple_menu` (`id`, `name`, `published`, `ordering`, `lng`) VALUES
(1, 'منوی بالا', 1, 1, 'fa'),
(2, 'سایر منوها', 0, 3, 'fa'),
(3, 'منوی پایین', 1, 2, 'fa');

-- --------------------------------------------------------

--
-- Table structure for table `apple_menu_items`
--

CREATE TABLE IF NOT EXISTS `apple_menu_items` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `menu` bigint(20) unsigned NOT NULL default '1',
  `parent` bigint(20) NOT NULL,
  `url` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `icon` varchar(255) default NULL,
  `image` varchar(255) default NULL,
  `target` varchar(25) default '_self',
  `internal` tinyint(1) default '1',
  `ispage` tinyint(1) default '1',
  `published` tinyint(1) default '1',
  `ordering` bigint(20) default '1',
  PRIMARY KEY  (`id`),
  KEY `menu_id` (`menu`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT AUTO_INCREMENT=3 ;

--
-- Dumping data for table `apple_menu_items`
--

INSERT INTO `apple_menu_items` (`id`, `menu`, `parent`, `url`, `title`, `icon`, `image`, `target`, `internal`, `ispage`, `published`, `ordering`) VALUES
(1, 1, 0, '?lng=fa', 'صفحه اول', NULL, '', '_self', 1, 0, 1, 1),
(2, 1, 0, '?com=contact&lng=fa', 'تماس با ما', NULL, '', '_self', 1, 0, 1, 2);

-- --------------------------------------------------------

--
-- Table structure for table `apple_modules`
--

CREATE TABLE IF NOT EXISTS `apple_modules` (
  `id` int(11) NOT NULL auto_increment,
  `title` text NOT NULL,
  `show_title` tinyint(1) default '1',
  `module` varchar(20) default NULL,
  `position` int(10) NOT NULL,
  `style` varchar(10) default 'horizontal',
  `published` tinyint(1) NOT NULL default '0',
  `ordering` int(11) default '1',
  `lng` varchar(10) NOT NULL default 'fa',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT AUTO_INCREMENT=4 ;

--
-- Dumping data for table `apple_modules`
--

INSERT INTO `apple_modules` (`id`, `title`, `show_title`, `module`, `position`, `style`, `published`, `ordering`, `lng`) VALUES
(1, 'منو', 0, 'menu', 5, 'horizontal', 1, 2, 'fa'),
(2, 'آخرین مطالب', 1, 'latest_contents', 6, 'vertical', 0, 6, 'fa'),
(3, 'محبوب ترینها', 1, 'most_visited', 4, 'vertical', 0, 1, 'fa');

-- --------------------------------------------------------

--
-- Table structure for table `apple_modules_params`
--

CREATE TABLE IF NOT EXISTS `apple_modules_params` (
  `id` int(11) NOT NULL,
  `key` varchar(100) NOT NULL,
  `value` text NOT NULL,
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `apple_modules_params`
--

INSERT INTO `apple_modules_params` (`id`, `key`, `value`) VALUES
(2, 'limit', '5'),
(2, 'details', '1'),
(2, 'id', '0'),
(1, 'css', 'nav'),
(1, 'title_css', 'header'),
(1, 'body_css', 'body'),
(1, 'id', '1'),
(3, 'limit', '5'),
(3, 'css', 'box'),
(3, 'title_css', 'header'),
(3, 'body_css', 'body'),
(3, 'id', '0');

-- --------------------------------------------------------

--
-- Table structure for table `apple_modules_positions`
--

CREATE TABLE IF NOT EXISTS `apple_modules_positions` (
  `id` int(11) NOT NULL default '0',
  `menu` bigint(20) NOT NULL,
  PRIMARY KEY  (`id`,`menu`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Dumping data for table `apple_modules_positions`
--

INSERT INTO `apple_modules_positions` (`id`, `menu`) VALUES
(1, 0),
(2, 1),
(3, 0);

-- --------------------------------------------------------

--
-- Table structure for table `apple_settings`
--

CREATE TABLE IF NOT EXISTS `apple_settings` (
  `key` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `comments` text,
  `lng` varchar(10) default 'fa'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `apple_settings`
--

INSERT INTO `apple_settings` (`key`, `value`, `comments`, `lng`) VALUES
('title', 'Apple', '', 'fa'),
('url', 'http://localhost/Apple/1.0 BETA', '', 'fa'),
('name', 'Apple', '', 'fa'),
('description', '', '', 'fa'),
('keywords', '', '', 'fa'),
('copyright', '<a href="http://www.applecms.org" target=_blank>\r\nPowered by Apple</a> | \r\n<a href="http://www.parsiserve.com" target=_blank>Hosted by Parsiserve</a>', '', 'fa'),
('date_type', 'jalali', '', 'fa'),
('date_format', 'd F Y', '', 'fa'),
('time_format', 'G:i:s', '', 'fa'),
('gmt_offset', '3:30', '', 'fa'),
('translate', '0', '', 'fa'),
('contact', '2', '0 = system, 1 = mail, 2 = both of them', 'fa'),
('mailer', 'mail', '', 'fa'),
('admin_theme', 'default', '', 'fa'),
('direction', 'rtl', '', 'fa'),
('sef', 'on', 'SEF url', 'fa'),
('default_component', 'home', '', 'fa');

-- --------------------------------------------------------

--
-- Table structure for table `apple_theme`
--

CREATE TABLE IF NOT EXISTS `apple_theme` (
  `theme` varchar(255) NOT NULL default 'Apple',
  `menu` bigint(20) NOT NULL default '0',
  `lng` varchar(10) NOT NULL default 'fa'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

--
-- Dumping data for table `apple_theme`
--

INSERT INTO `apple_theme` (`theme`, `menu`, `lng`) VALUES
('Apple', 0, 'fa');

-- --------------------------------------------------------

--
-- Table structure for table `apple_theme_positions`
--

CREATE TABLE IF NOT EXISTS `apple_theme_positions` (
  `id` int(10) unsigned NOT NULL,
  `position` varchar(20) NOT NULL,
  `description` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `apple_theme_positions`
--

INSERT INTO `apple_theme_positions` (`id`, `position`, `description`) VALUES
(1, 'top', ''),
(2, 'left', ''),
(3, 'bottom', ''),
(4, 'right', ''),
(5, 'menu', ''),
(6, 'top_content', ''),
(7, 'bottom_content', '');

-- --------------------------------------------------------

--
-- Table structure for table `apple_users`
--

CREATE TABLE IF NOT EXISTS `apple_users` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `username` varchar(64) NOT NULL,
  `password` varchar(64) NOT NULL,
  `credit` varchar(20) default '0',
  `credit_remain` varchar(20) default '0',
  `name` varchar(255) NOT NULL,
  `email` varchar(100) NOT NULL,
  `tel` varchar(100) default '----',
  `mobile` varchar(100) default '----',
  `address` text,
  `show_email` tinyint(1) default '1',
  `show_tel` tinyint(1) default '1',
  `show_mobile` tinyint(1) default '1',
  `show_address` tinyint(1) default '1',
  `reg_date` date default NULL,
  `group` int(11) default '2',
  `last_login` datetime NOT NULL,
  `ch_pass` varchar(20) default '0',
  `ch_pass_time` int(11) default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT AUTO_INCREMENT=2 ;

--
-- Dumping data for table `apple_users`
--

INSERT INTO `#__users` (`id`, `username`, `password`, `name`, `email`, `tel`, `mobile`, `address`, `show_email`, `show_tel`, `show_mobile`, `show_address`, `reg_date`, `group`, `last_login`, `ch_pass`, `ch_pass_time`) VALUES
(1, 'admin', '21232f297a57a5a743894a0e4a801fc3', 'Admin', 'ali@parsiserve.com', '', '', '', 0, 0, 0, 0, NULL, 1, '', '0', '0');

--
-- Constraints for dumped tables
--

--
-- Constraints for table `apple_menu_items`
--
ALTER TABLE `apple_menu_items`
  ADD CONSTRAINT `apple_menu_items_ibfk_1` FOREIGN KEY (`menu`) REFERENCES `apple_menu` (`id`);

--
-- Constraints for table `apple_modules_params`
--
ALTER TABLE `apple_modules_params`
  ADD CONSTRAINT `modules_params_ibfk_1` FOREIGN KEY (`id`) REFERENCES `apple_modules` (`id`) ON DELETE CASCADE;

--
-- Constraints for table `apple_modules_positions`
--
ALTER TABLE `apple_modules_positions`
  ADD CONSTRAINT `modules_positions_ibfk_1` FOREIGN KEY (`id`) REFERENCES `apple_modules` (`id`) ON DELETE CASCADE;
