<?php
/**
 * @package Apple
 * @author Parsiserve Inc.
 * @copyright Parsiserve Inc. http://www.parsiserve.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see license.txt
 * Apple is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; version 2 of the License.
 */

/**
 * Main Apple API
 */

defined('ACCESS_ALLOW') or die('<H1>Forbidden</H1>You are not allowed to be here<hr>');

class AppleUser {
	static private $instance = null;
	protected $database;

	public function __construct() {
		$this->database = db::getInstance();
		if (is_object($_SESSION['user'])) {
			foreach (get_object_vars($_SESSION['user']) as $k=>$v) {
				$this->$k = $v;
			}
		}
	}
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new AppleUser();
		return self::$instance;
	}
	
	public function checkUser($username='username', $password='password') {
		$user = AppleGetParam($username, $_POST);
		$pass = md5(AppleGetParam($password, $_POST));
		$this->database->setQuery("SELECT * FROM `#__users` WHERE `$username` = '$user' AND `$password` = '$pass'");
		$user = $this->database->loadObject();
		if ($user) {
			$obj = new stdClass();
			$obj->last_login = AppleGetNow('Y-m-d H:i:s');
			$this->database->update('`#__users`', $obj, "username='$user->username'");
			$_SESSION['user'] = $user;
			return $user;
		}
		return null;
	}
	
	public function resetPassword() {
		$username = AppleGetParam('username', $_POST);
		$email = AppleGetParam('email', $_POST);
		$this->database->setQuery("SELECT * FROM `#__users` WHERE `username` = '$username' AND `email` = '$email'");
		$obj = $this->database->loadObject();
		if ($obj) {
			$password = AppleGeneratePassword();
			$password2 = md5($password);
			$this->database->setQuery("UPDATE `#__users` SET password = '$password2' WHERE `username` = '$username' AND `email` = '$email'");
			if ($this->database->query()) {
				$body = 'new password : '.$password;
				if (AppleMail(null, null, $email, 'new password', $body, true)) return 'new password sent';
				else return 'unknown_error';
			}
			else return 'unknown_error';
		}
		return 'invalid_user';
	}
	
	public function get($attribute) {
		return $this->$attribute;
	}
	
	public function logout() {
		@session_destroy();
	}
}

/**
 * this class gets theme and parse it
 *
 */
class AppleTheme {
	static private $instance = null;
	private $title = null;
	private $keywords = null;
	public $buffer;
	protected $database;
		
	public function __construct() {
		$this->database = db::getInstance();
		$this->buffer = buffer::getInstance();
	}
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new AppleTheme();
		return self::$instance;
	}
	
	/**
	 * get theme from database
	 *
	 * @return string html with [content] & [pos:*]
	 */
	public function getTheme() {
		global $com;
		
		$this->loadComponent();
		
		$Apple_menu_id = AppleGetMenuId($_SERVER['QUERY_STRING']);
		$component_menu_id = AppleGetComponentMenuId();
		
		$menu = $Apple_menu_id != 0 ? $Apple_menu_id : $component_menu_id;
		
		$this->database->setQuery("SELECT theme FROM `#__theme`
		WHERE (`menu`=$menu OR `menu`=0) AND `lng` = '".LANGUAGE."'
		ORDER BY menu DESC");
		$theme = $this->database->loadObject();
		$theme = $theme->theme;
		
		if (!file_exists(Apple_root_path.'/themes/'.$theme.'/index.tpl')) {
			if (file_exists(Apple_root_path.'/themes/Apple/index.tpl')) {
				$tmp = file_get_contents(Apple_root_path.'/themes/Apple/index.tpl');
			}
			else {
				echo __('There is no theme to show your Website!');
				return ;
			}
		}
		else $tmp = file_get_contents(Apple_root_path.'/themes/'.$theme.'/index.tpl');
		
		$keys = array('url','name','description','copyright');
		foreach ($keys as $b =>$c) {
			$tmp = @str_replace('['.$c.']', settings::get($c), $tmp);
		}
		
		$tmp = @str_replace('[language]', LANGUAGE, $tmp);
		
		if (strstr($tmp, '<head>')) $tmp = str_replace('<head>', "<head>\r\n<base href=\"".settings::get('url')."/\" />\r\n", $tmp);
		elseif (strstr($tmp, '<html>')) $tmp = str_replace('<html>', "<html>\r\n<base href=\"".settings::get('url')."/\" />\r\n", $tmp);
		else echo "<base href=\"".settings::get('url')."/\" />\r\n";
		
		//$format = preg_replace("/(.*)(\[date)( )(.*)(\])(.*)/", "$4", $tmp);
		$preg = preg_split("/(\[date.*\])/U", $tmp, -1, PREG_SPLIT_DELIM_CAPTURE);
		$preg = $preg[1];
		$format = preg_replace("/(\[date)( )(.*)(\])/", "$3", $preg);
		$tmp = preg_replace("/(\[date.*\])/", AppleDate(null, $format, 0, 0), $tmp);
		$tmp = @str_replace('[dir]', settings::get('direction'), $tmp);
		$tmp = @str_replace('[version]', Apple_version, $tmp);
		
		$this->setTitle(settings::get('title'));
		$this->setKeywords(settings::get('keywords'));
		return $tmp;
	}
	
	public function execute($tmp) {
		if (AppleGetParam('load_theme', $_GET, 'yes') == 'no' || AppleAjaxRequest()) $this->loadComponent();
		$this->setHeaders($tmp);
		$tmp = explode('[content]',$tmp);
		if ($tmp[0] != null) $this->loadPositions($tmp[0]);
		$this->buffer->out();
		if ($tmp[1] != null) $this->loadPositions($tmp[1]);
		$this->buffer->stop();
	}
	
	/**
	 * loading the current component AND store it in buffer
	 * NOTICE : JUST stores the output from current component
	 *
	 */
	public function loadComponent() {
		global $com;
		$c = buffer::getInstance();
		$this->buffer->start();
		if (file_exists(Apple_root_path."/components/$com/index.php")) {
			@include (Apple_root_path."/components/$com/$com.class.php");
			@include (Apple_root_path."/components/$com/$com.html.php");
			require_once (Apple_root_path."/components/$com/index.php");
		}
		else {
			@include (Apple_root_path."/components/content/content.class.php");
			@include (Apple_root_path."/components/content/content.html.php");
			require_once (Apple_root_path."/components/content/index.php");
		}
		$this->buffer->stop();
	}
	
	/**
	 * load modules in their positions
	 *
	 * @param string html
	 */
	private function loadPositions($tmp) {
		global $com;
		$Apple_menu_id = AppleGetMenuId($_SERVER['QUERY_STRING']);
		$component_menu_id = AppleGetComponentMenuId();
		
		$textarr = preg_split("/(\[pos:.*\])/U", $tmp, -1, PREG_SPLIT_DELIM_CAPTURE);
		$stop = count($textarr);
		for($i = 0;$i<$stop;$i++) {
			if (!strstr($textarr[$i],'[pos:')) echo $textarr[$i];
			if (strstr($textarr[$i],'[pos:')) {
				$position = explode('[pos:',$textarr[$i]);
				$position = str_replace(']',null,$position[1]);
				
				$this->database->setQuery("SELECT a.* FROM `#__modules` AS a
				INNER JOIN `#__modules_positions` AS b ON (b.menu = '0' OR b.menu = '$Apple_menu_id' OR b.menu = '$component_menu_id')
				INNER JOIN `#__theme_positions` AS c ON c.position = '$position' 
				WHERE a.position = c.id AND a.published = '1' AND a.id = b.id AND a.lng='".LANGUAGE."'
				GROUP BY a.id
				ORDER BY a.ordering");
				$list = $this->database->loadObjectList();
				foreach ((array)$list as $module) {
					$module->param = AppleGetParams('`#__modules_params`', $module->id);
					$this->loadModule($module);
				}
			}
		}
	}
	
	/**
	 * include module file
	 *
	 * @param object module
	 */
	private function loadModule($module) {
		$database = $this->database;
		$name = $module->module;
		if (!file_exists(Apple_root_path."/modules/$name/index.php")) return ;
		$class = "AM__$name";
		if (!class_exists($class)) {
			include (Apple_root_path."/modules/$name/index.php");
		}
		if (class_exists($class)) new $class($module);
	}
	
	public function setHeaders(&$tmp) {
		$tmp = @str_replace('[title]', $this->title, $tmp);
		$tmp = @str_replace('[keywords]', $this->keywords, $tmp);
		
		$path = ApplePath::getInstance();
		$tmp = @str_replace('[path]', $path->makePath(), $tmp);
	}
	
	public function setTitle($title) {
		if ($this->title != null) $this->title .= ' &raquo; ';
		$this->title .= $title;
	}
	
	public function setKeywords($keywords) {
		$this->keywords .= ($this->keywords && $keywords) ? ', '.$keywords : $keywords;
	}
}

class AppleAdminTheme {
	static private $instance = null;
	private $title = null;
	private $keywords = null;
	private $buffer;
		
	public function __construct() {
		$this->buffer = buffer::getInstance();
	}
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new AppleAdminTheme();
		return self::$instance;
	}
	
	/**
	 * get theme from database
	 *
	 * @return string html with [content]
	 */
	public function getTheme() {
		global $database, $com;
		/*$database->setQuery("SELECT * FROM `#__admin_theme`");
		$tmp = $database->loadObject();
		if (empty($tmp)) return;
		$tmp = $tmp->theme;*/
		
		
		$theme = settings::get('admin_theme');
		
		if (!file_exists(Apple_root_path.'/admin/themes/'.$theme.'/index.tpl')) {
			if (file_exists(Apple_root_path.'/admin/themes/Apple/index.tpl')) {
				$tmp = file_get_contents(Apple_root_path.'/admin/themes/Apple/index.tpl');
			}
			else {
				echo __('There is no theme to show your Website!');
				return ;
			}
		}
		else $tmp = file_get_contents(Apple_root_path.'/admin/themes/'.$theme.'/index.tpl');
		
		$keys = array('url','name', 'title');
		foreach ($keys as $b =>$c) {
			$tmp = @str_replace('['.$c.']', settings::get($c), $tmp);
		}
		
		$tmp = @str_replace('[dir]', settings::get('direction'), $tmp);
		$tmp = @str_replace('[version]', Apple_version, $tmp);
		
		if (strstr($tmp, '<head>')) $tmp = str_replace('<head>', "<head>\r\n<base href=\"".settings::get('url')."/admin/\" />\r\n", $tmp);
		elseif (strstr($tmp, '<html>')) $tmp = str_replace('<html>', "<html>\r\n<base href=\"".settings::get('url')."/admin/\" />\r\n", $tmp);
		else echo "<base href=\"".settings::get('url')."/admin/\" />\r\n";
		
		return $tmp;
	}
	
	public function execute($tmp) {
		$this->loadComponent();
		$tmp = @str_replace('[message]', AppleShowMessage(), $tmp);
		$path = ApplePath::getInstance();
		$tmp = @str_replace('[path]', $path->makePath(), $tmp);
		$tmp = explode('[content]',$tmp);
		if ($tmp[0] != null) $this->loadModules($tmp[0]);
		$this->buffer->out();
		if ($tmp[1] != null) $this->loadModules($tmp[1]);
	}
	
	public function loadComponent() {
		global $com, $database;
		$this->buffer->start();
		if (file_exists(Apple_root_path."/admin/components/$com/index.php")) {
			@include (Apple_root_path."/admin/components/$com/$com.class.php");
			@include (Apple_root_path."/admin/components/$com/$com.html.php");
			require_once (Apple_root_path."/admin/components/$com/index.php");
		}
		else {
			@include (Apple_root_path."/admin/components/content/content.class.php");
			@include (Apple_root_path."/admin/components/content/content.html.php");
			require_once (Apple_root_path."/admin/components/content/index.php");
		}
		$this->buffer->stop();
	}
	
	private function loadModules($tmp) {
		$textarr = preg_split("/(\[mod:.*\])/U", $tmp, -1, PREG_SPLIT_DELIM_CAPTURE);
		$stop = count($textarr);
		for($i = 0;$i<$stop;$i++) {
			if (!strstr($textarr[$i],'[mod:')) echo $textarr[$i];
			if (strstr($textarr[$i],'[mod:')) {
				$module = explode('[mod:',$textarr[$i]);
				$module = str_replace(']',null,$module[1]);
				$this->loadModule($module);		
			}
		}
	}
	
	private function loadModule($module) {
		global $database;
		if (!file_exists(Apple_root_path."/admin/modules/$module/index.php")) return;
		
		$class = "AM__$module";
		if (!class_exists($class)) {
			include (Apple_root_path."/admin/modules/$module/index.php");
			if (class_exists($class)) new $class();
		}
	}
}

class AppleMailer extends PHPMailer {
	public function __construct($from = null, $from_name = null, $subject, $body) {
		$this->PluginDir = Apple_root_path.'/kernel';
		$this->CharSet = substr_replace(_ISO, '', 0, 8);
		$this->IsMail();
		$this->From = ($from) ? $from : settings::get('email');
		$this->FromName = ($from_name) ? $from_name : settings::get('name');
		$this->Mailer = settings::get('mailer');

		// Add smtp values if needed
		if ($this->Mailer ==  'smtp') {
			$this->SMTPAuth = '';
			$this->Username = '';
			$this->Password = '';
			$this->Host = '';
		}

		$this->Subject = $subject;
		$this->Body = $body;
	}
	
	public function mail($recipient, $html = false, $cc = null, $bcc = null, $attachment = null, $reply_to = null, $reply_to_name = null ) {
		if ($html) $this->IsHTML(true);
		
		if (is_array($recipient)) foreach ($recipient as $to) $this->AddAddress($to);
		else $this->AddAddress($recipient);
		
		if (isset($cc)) {
		    if (is_array($cc)) foreach ($cc as $to) $this->AddCC($to);
		    else $this->AddCC($cc);
		}
		
		if (isset($bcc)) {
		    if (is_array($bcc)) foreach ($bcc as $to) $this->AddBCC($to);
		    else $this->AddBCC($bcc);
		}
	    
		if ($attachment) {
	        if (is_array($attachment)) foreach ($attachment as $fname) $this->AddAttachment($fname);
	        else $this->AddAttachment($attachment);
	    }
	    
	    if ($reply_to) {
	        if (is_array($reply_to)) {
	        @reset($reply_to_name);
	            foreach ($reply_to as $to) {
	            	$toName = ((list($key, $value) = each($reply_to_name)) ? $value : '');
	            	$this->AddReplyTo($to, $toName);
	            }
	        }
	        else $this->AddReplyTo($reply_to, $reply_to_name);
	    }
		return $this->Send();
	}
}

class settings {
	static private $instance = null;
	public $root_path = Apple_root_path;
	public $sub_directory = null;
	static private $setting = array();
	protected $database;
	
	public function __construct() {
		$this->database = db::getInstance();
		$this->database->setQuery("SELECT * FROM #__settings WHERE `lng` = '".LANGUAGE."'");
		self::$setting = $this->database->loadObjectList('key');
		
		// Remove slashes after the url
		while (ereg('/$', self::$setting['url']->value)) {
			self::$setting['url']->value = ereg_replace('/$', '', self::$setting['url']->value);
		}
		
		// Now some other properties
		// Find information about where execution started
		$origin = array_pop(debug_backtrace());
		// Find the PHP script at the start, with a fix for windows slashes
		$absolutepath = str_replace('\\', '/', $origin['file']);
		$localpath = $_SERVER['PHP_SELF'];
		$root = substr($absolutepath,0,strpos($absolutepath,$localpath));
		$Apple_root = str_replace('\\', '/', rtrim($this->root_path, '\/'));
		$this->sub_directory = substr($Apple_root, strlen($root));
		
		foreach (get_object_vars($this) as $k => $v) {
			self::$setting[$k]->value = $v;
		}
	}
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new settings();
		return self::$instance;
	}
	
	static function get($key) {
		return self::$setting[$key]->value;
	}
	
	public function set($key, $value) {
		$this->database->setQuery("UPDATE #__settings SET `value` = '$value' WHERE `key`='$key' AND `lng` = '".LANGUAGE."'");
		if ($this->database->query()) return true;
		return false;
	}
}

class buffer {
	static private $instance = null;
	public $buffer;
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new buffer();
		return self::$instance;
	}
	
	public function start() {
		$this->buffer = '';
		ob_start();
	}
	
	public function stop() {
		$this->buffer = ob_get_contents();
		ob_end_clean();
	}
	
	public function out() {
		echo $this->buffer;
	}
}

class ApplePath {
	static private $instance = null;
	private $item;
	private $seprator;
	
	public function __construct() {
		global $com;
		$this->seprator = ' &raquo; ';
		$this->item['title'][0] = __('Home Page');
		$this->item['url'][0] = ($com == settings::get('default_component')) ? null : '?lng='.LANGUAGE;
	}
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new ApplePath();
		return self::$instance;
	}
	
	public function addItem($title, $url) {
		if (empty($title)) return;
		$count = count($this->item['title']);
		$this->item['title'][$count] = $title;
		$this->item['url'][$count] = $url;
	}
	
	public function removeItem() {
		$count = count($this->item['title']);
		unset($this->item['title'][$count-1]);
		unset($this->item['url'][$count-1]);
	}
	
	public function removeAllItems() {
		$count = count($this->item['title']);
		for($i = $count; $i>0; $i--)
			$this->removeItem();
	}
	
	public function makePath() {
		$out = null;
		$count = count($this->item['title']);
		for($i = 0; $i<$count; $i++) {
			if ($this->item['url'][$i])
				$out .= '<a href = "'.AppleMakeSef($this->item['url'][$i]).'">'.$this->item['title'][$i].'</a>';
			else
				$out .= $this->item['title'][$i];
				
			if ($i<$count-1) $out .= $this->seprator;
		}
		return $out;
	}
}

class ApplePageNav {
	private $total;
	private $pages;
	public $page;
	public $limit;
	public $sql_limit;
	
	public function __construct($total, $limit=25) {
		$this->total = intval($total);
		$this->limit = intval($limit);
		$this->page = intval(AppleGetParam('page', $_GET, 1));
		$this->pages = ceil($this->total/$this->limit);
		if ($this->pages < 1) $this->pages = 1;
		if ($this->page > $this->pages) $this->page = $this->pages;
		if ($this->page < 1) $this->page = 1;
		$start = ($this->page-1)*$this->limit;
		$this->sql_limit = "LIMIT $start, $this->limit";
	}
	
	public function writePages($link=null) {
		if ($link == null) $link = '?'.$_SERVER['QUERY_STRING'];
		if ($this->pages == 1) return ;
		
		// Clear pages from URL
		$page = AppleGetParam('page', $_GET);
		$link = preg_replace("/(page=$page.&)/U", '', $link);
		$link = preg_replace("/(&page=$page)/U", '', $link);
		
		$out = '<div class="pagenav">
			<table cellpadding="0" cellspacing="0" border="0" dir="'.settings::get('direction').'">
			<tr>
				<td class="pages_counter" nowrap="nowrap"><span>'.sprintf(__('Page %s of %s'), $this->page, $this->pages).'</span></td>';
		
		$control = $this->pages < 12 ? 4 : 2;
		
		// First Page
		if ($this->page > $control+1) {
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link").'" title="'.__('First Page').' - '.sprintf(__('Results %s to %s of %s'), 1, $this->limit, number_format($this->total, null, null, ',')).'"><strong>&laquo; </strong> '.__('First').'</a></td>';
		}
		
		// Prev Page
		if ($this->page > 1) {
			$start = ($this->page-2)*$this->limit+1;
			$end = $start+$this->limit-1;
			if ($end > $this->total) $end = $this->total;
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef($link.($this->page == 2 ? "" : "&page=".($this->page-1))."").'" title="'.__('Prev Page').' - '.sprintf(__('Results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">&lt;</a></td>';
		}
				
		// Prev Pages
		$i = 1;
		$j = 5;
		while (true) {
			$i *= 10;
			if ($this->page-$i < 1) break;
			$j *= 10;
			if ($this->page-$j > 0) {
				$start = ($this->page-$j-1)*$this->limit+1;
				$end = $start+$this->limit-1;
				if ($end > $this->total) $end = $this->total;
				$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=".($this->page-$j)).'" title="'.sprintf(__('Show results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">'.($this->page-$j).'</a></td>';
			}
			
			$start = ($this->page-$i-1)*$this->limit+1;
			$end = $start+$this->limit-1;
			if ($end > $this->total) $end = $this->total;
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=".($this->page-$i)).'" title="'.sprintf(__('Show results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">'.($this->page-$i).'</a></td>';
		}
		
		// $control Prev Pages
		for ($i=$this->page-$control; $i<$this->page; $i++) {
			if ($i >= 1) {
				$start = ($i-1)*$this->limit+1;
				$end = $start+$this->limit-1;
				if ($end > $this->total) $end = $this->total;
				$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=$i").'" title="'.sprintf(__('Show results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">'.$i.'</a></td>';
			}
		}
		
		// Current Page
		$start = ($this->page-1)*$this->limit+1;
		$end = $start+$this->limit-1;
		if ($end > $this->total) $end = $this->total;
		$out .= '<td class="current"><span title="'.sprintf(__('Showing results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'"><strong>'.$this->page.'</strong></span></td>';
		
		// $control Next Pages
		for ($i=$this->page+1; $i<$this->page+$control+1; $i++) {
			if ($i <= $this->pages) {
				$start = ($i-1)*$this->limit+1;
				$end = $start+$this->limit-1;
				if ($end > $this->total) $end = $this->total;
				$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=$i").'" title="'.sprintf(__('Show results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">'.$i.'</a></td>';
			}
		}
		
		// Next Pages
		$i = 1;
		$j = 5;
		while (true) {
			$i *= 10;
			if ($this->page+$i >= $this->pages) break;
			$start = ($this->page+$i-1)*$this->limit+1;
			$end = $start+$this->limit-1;
			if ($end > $this->total) $end = $this->total;
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=".($this->page+$i)).'" title="'.sprintf(__('Show results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">'.($this->page+$i).'</a></td>';
			$j *= 10;
			if ($this->page+$j >= $this->pages) break;
			$start = ($this->page+$j-1)*$this->limit+1;
			$end = $start+$this->limit-1;
			if ($end > $this->total) $end = $this->total;
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=".($this->page+$j)).'" title="'.sprintf(__('Show results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">'.($this->page+$j).'</a></td>';
		}
		
		// Next Page
		if ($this->page < $this->pages) {
			$start = ($this->page)*$this->limit+1;
			$end = $start+$this->limit-1;
			if ($end > $this->total) $end = $this->total;
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=".($this->page+1)."").'" title="'.__('Next Page').' - '.sprintf(__('Results %s to %s of %s'), number_format($start, null, null, ','), number_format($end, null, null, ','), number_format($this->total, null, null, ',')).'">&gt;</a></td>';
		}
		
		// Last Page
		if ($this->page < $this->pages-$control) {
			$start = ($this->pages-1)*$this->limit+1;
			$out .= '<td nowrap="nowrap"><a href="'.AppleMakeSef("$link&page=$this->pages").'" title="'.__('Last Page').' - '.sprintf(__('Results %s to %s of %s'), number_format($start, null, null, ','), number_format($this->total, null, null, ','), number_format($this->total, null, null, ',')).'">'.__('Last').' <strong>&raquo; </strong></a></td>';
		}
		
		$out .= '</tr>
			</table>
		</div>';
		
		return $out;
	}
}

class AppleXmlReader {
	private $file;
	private  $level;
	protected $tag=array();
	protected $char_data;
	protected $name, $parameters;
	
	public function __construct($file, $parameters=null, $name='params') {
		$this->file = $file;
		$this->level = 0;
		$this->char_data = null;
		$this->name = $name;
		$this->parameters = $parameters;
		
		/* Create the parser handle */
		$xml = xml_parser_create('UTF-8');
		
		/* Set the handlers */
		xml_set_element_handler($xml, array($this, 'start_handler'), array($this, 'end_handler'));
		xml_set_character_data_handler($xml, array($this, 'character_handler'));
		
		/* Start parsing the whole file in one run */
		xml_parse($xml, file_get_contents($this->file));
		
		xml_parser_free($xml);
	}
	
	private function start_handler ($xml, $tag, $attributes) {
		$method = 'start_'.$tag;
		if (is_callable(array(&$this, $method))) $this->$method($attributes);
		$this->level++;
	}
	
	private function end_handler ($xml, $tag) {
		$method = 'end_'.$tag;
		$specific = array (&$this, $method);
		if (is_callable($specific)) $this->$method();
		$this->level--;
		$this->tag[$tag] = $this->char_data;
		$this->char_data = null;
	}
	
	private function character_handler ($xml, $data) {
		$this->char_data .= ' '.$data;
	}
}

class AppleModuleParser extends AppleXmlReader {
	private $attribute;
	private $options = array(), $optionValue;
	public  $out  = array();
	public  $params  = array();
	
	public function getTag($tag) {
		return $this->tag[strtoupper($tag)];
	}
	
	protected function start_param($attribute) {
		$this->attribute = $attribute;
	}
	
	protected function start_option($attribute) {
		$this->optionValue = AppleGetParam('VALUE', $attribute, null);
	}
	
	protected function end_option() {
		$form = new AppleHTML();
		$this->options[] = AppleHTML::makeOption($this->optionValue, $this->char_data);
		$this->optionValue = null;
	}
	
	protected function end_param() {
		$type = AppleGetParam('TYPE', $this->attribute, null);
		$name = AppleGetParam('NAME', $this->attribute, null);
		$default = AppleGetParam('DEFAULT', $this->attribute, null);
		$label = __(AppleGetParam('LABEL', $this->attribute, null));
		$description = __(AppleGetParam('DESCRIPTION', $this->attribute, null));
		
		/* valid tags */
		if (!in_array($type, array("text", "radio", "checkbox", "list"))) return;
		
		$name2 = str_replace('[]', '', $name);
		if ($name2 == $this->parameters[$name2]->key) $value = $this->parameters[$name2]->value;
		else $value = $default;
		
		$name = 'param_'.$name.'';
		$this->params[] = $name;
		$id = AppleGetParam('ID', $this->attribute, null);
		$class = 'class="'.AppleGetParam('CLASS', $this->attribute, null).'"';
		$style = 'style="'.AppleGetParam('STYLE', $this->attribute, null).'"';
		$length = 'length="'.AppleGetParam('LENGTH', $this->attribute, null).'"';
		$extra = "$class $style $length";
		
		$form = new AppleHTML();
		$this->out[] = '<tr><td>'.$label.' : </td><td>';
		switch ($type) {
			case 'text':
				$this->out[] = $form->makeText($name, $value, $extra);
				break;
			case 'radio':
			case 'check':
				$this->out[] = $form->makeRadio($this->options, $name);
				break;
			case 'list':
				$multiple = AppleGetParam('MULTIPLE', $this->attribute, null);
				$sql = AppleGetParam('LIST', $this->attribute, null);
				if ($sql != null) {
					$v = AppleGetParam('VALUE', $this->attribute, "id");
					$t = AppleGetParam('TEXT', $this->attribute, "title");
					global $database;
					$database->setQuery($sql);
					$list = $database->loadObjectList();
					foreach ((array)$list as $k) {
						$this->options[] = AppleHTML::makeOption($k->$v, $k->$t);
					}
				}
				
				if ($multiple != null) $extra .= ' multiple="multiple"';
				$value = explode(',', $value);
				$this->out[] = $form->makeList($this->options, $name, $extra, $value);
				break;
		}
		$this->out[] = '</td><td></td></tr>';
		$this->options = array();
		$this->attribute = array();
	}
}

class AppleCache {
	
	/**
	* @return object A function cache object
	*/
	public function getCache($group='') {
		require_once(Apple_root_path.'/kernel/Cache_Lite/Lite/Function.php');
		$caching = settings::get('caching');
		$path = settings::get('cachepath');
		$time = settings::get('cachetime');
		$options = array(
		'defaultGroup' => $group,
		'caching' => $caching,
		'cacheDir' => "$path/",
		'lifeTime' => $time
		);
		
		$cache = new Cache_Lite_Function($options);
		return $cache;
	}
	
	public function clean($group=false) {
		if (settings::get('caching')) {
			$cache = AppleCache::getCache($group);
			$cache->clean($group);
		}
	}
}

/**
 * Fetches objects from database AND sort
 *
 * @param string $table
 * @param integer $root
 * @param string $where
 * @param boolean $children
 * @param integer $limit_start
 * @param integer $limit_length
 * @return array
 */
class AppleMakeTree {
	public $list = array();
	
	public function __construct($table, $root, $where=null, $children=true, $limit_start=0, $limit_length=25) {
		global $database;
		
		$database->setQuery("SELECT * FROM $table WHERE parent=$root AND $where ORDER BY parent,ordering");
		$rows = $database->loadObjectList();
		$count = count($rows);
		
		if ($count == 0) return ;
		
		$list = array();
		$list = array_merge($list, $rows);
		
		if ($children) {
			while (!empty($rows)) {
				$temp = null;
				for ($i=0; $i<count($rows); $i++) {
					if ($temp != null) $temp .= ',';
					$temp .= $rows[$i]->id;
				}
				$database->setQuery("SELECT * FROM $table WHERE parent IN ($temp) AND $where ORDER BY parent,ordering");
				$rows = $database->loadObjectList();
				if (!empty($rows)) $list = array_merge($list, $rows);
			}
		}
		$this->sort($list, $limit_start, $limit_length);
	}
	
	public function sort($rows, $limit_start=0, $limit_length=25) {
		$count = count($rows);
		if ($count == 0) return ;
		
		$parent = array();
		$child = array();
		$last = 0;
		$i = 0;
		$start = 'unknown';
		foreach ($rows as $v ) {
			if ($start == 'unknown') $start = $v->parent;
			$parent[$v->id] = $v->parent;
			if ($last != $v->parent) {
				$i = 0;
				$last = $v->parent;
			}
			$child[$v->parent][$i++] = $v;
		}
		
		$stack = array();
		$i = $start;
		array_push($stack, $i);
		while (count($this->list) < $count) {
			if ($child[$i] != null) {
				$x = array_shift($child[$i]);
				$level = 0;
				$id = $x->id;
				while ($parent[$id] > 0) {
					$level++;
					$id = $parent[$id];
				}
				$x->level = $level;
				array_push($this->list, $x);
				if ($child[$i] != null)  array_push($stack, $i);
				$i = $x->id;
			}
			elseif ($i != 0) {
				$i = array_pop($stack);
			}
			else break;
		}
		
		unset($child);
		unset($parent);
		unset($stack);
		if ($limit_length != 0) $this->list = array_slice($this->list, $limit_start, $limit_length);
		return $this->list;
	}
}

class AppleFileManager {
	private $root_path, $url;
	protected $path, $parent, $parent_address, $folder;
	private $absolute_path;
	protected $folders = array();
	protected $files = array();
	public $file, $error;
	
	public function __construct($root_path=null, $url=null) {
		$this->root_path = ($root_path == null) ? Apple_root_path.'/uploads' : $root_path;
		$this->url = ($url == null) ? settings::get('url').'/uploads' : $url;
		
		$this->path = AppleGetParam('path', $_GET);
		$this->file = AppleGetParam('file', $_GET);
		$path = explode('/', $this->path);
		if (!$this->securePath($path)) die('Attack found!');
		$this->path = $this->trim($path);
		$this->absolute_path = $this->root_path.($this->path != null ? $this->path : '');
		$this->absolute_path = preg_replace("/(\/{1,}$)/", '', $this->absolute_path);
	}
	
	/**
	 * Gets attributes (such as private attributes)
	 *
	 * @param string $name
	 * @return string attribute
	 */
	public function get($name) {
		return $this->$name;
	}
	
	/**
	 * Trims the path
	 *
	 * @param array $path
	 * @return string
	 */
	public function trim($path) {
		$stack = array();
		foreach ($path as $file) {
			if ($file != null) {
				$stack[] = $file;
			}
		}
		
		$path = '/';
		$count = count($stack);
		$path .= implode('/', $stack);
		
		$this->parent_address = ($count > 0) ? 'uploads' : '';
		$this->parent = ($count > 0) ? 'uploads' : '';
		for ($i=0; $i<$count-1; $i++) {
			$this->parent_address .= '/'.$stack[$i];
			$this->parent = $stack[$i];
		}
		$this->folder = $stack[$count-1];
		return $path;
	}
	
	/**
	 * Checks path for security
	 *
	 * @param array $path
	 * @return FALSE if found bad name such as '..' ;-)
	 */
	private function securePath($path) {
		foreach($path as $name) {
			if ($name == '..' || $name == '.') return false;
		}
		return true;
	}
	
	public function listAll() {
		$dir = @dir($this->absolute_path);
		if ($dir == null) {
			$this->error = __('Root directory not found');
			return false;
		}
		
		while (($file = $dir->read()) != null) {
			if (is_file($this->absolute_path.'/'.$file)) array_push($this->files, $file);
			elseif ($file != '.' && $file != '..') array_push($this->folders, $file);
		}
	}
	
	public function createFolder($name) {
		if ($name == null || eregi("[^0-9A-z_]", $name)) {
			$this->error = __('Folder name must only contain alphanumeric characters.');
			return false;
		}
		$folder = $this->absolute_path.'/'.$name;
		if (file_exists($folder)) {
			$this->error = sprintf(__('Folder <b>%s</b> is already exists.'), $name);
			return false;
		}
		
		if (!mkdir($folder, 0777)) {
			$this->error = sprintf(__('Folder <b>%s</b> not created'), $name);
			return false;
		}
		$fp = fopen($folder."/index.html", "w" );
		fwrite( $fp, "<H1>Forbidden</H1>You are not allowed to be here<hr>");
		fclose( $fp );
		return true;
	}
	
	public function copy($from, $to, $force=true) {
		if (!$force) {
			if (file_exists($to)) return false;
		}
		
		if (file_exists($to)) {
			$parent = $this->getParent($to);
			$x = basename($to);
			$c = false;
			for ($i=1; !$c; $i++) {
				if ($i == 1) $to = $parent.'/Copy of '.$x;
				elseif ($i == 2) $to = $parent.'/Another copy of '.$x;
				elseif ($i == 3) $to = $parent.'/3rd copy of '.$x;
				elseif ($i == 4) $to = $parent.'/4th copy of '.$x;
				elseif ($i%20 == 1 && $i > 20) $to = $parent.'/'.$i.'st copy of '.$x;
				elseif ($i%20 == 2 && $i > 20) $to = $parent.'/'.$i.'nd copy of '.$x;
				elseif ($i%20 == 3 && $i > 20) $to = $parent.'/'.$i.'rd copy of '.$x;
				else $to = $parent.'/'.$i.'th copy of '.$x;
				
				$c = !file_exists($to);
			}
		}
		if ($this->makeDir($to)) {
			if (is_file($from)) return copy($from, $to);
			else return $this->copyTree($from, $to);
		}
		return false;
	}
	
	public function makeDir($dir) {
		if (file_exists($dir)) {
			return is_dir($dir) && is_writable($dir);
		}
		$parent = $this->getParent($dir);
		if (!$this->makeDir($parent)) return false;
		if (!is_dir($parent) || !is_writable($parent)) return false;
		return @mkdir($dir, 0777);
	}
	
	public function getParent($dir) {
		return dirname($dir);
	}
	
	public function copyTree($from, $to) {
		$dir= @dir($from);
		while (($file = $dir->read()) != null) {
			if (is_file("$from/$file")) {
				if (!file_exists("$to/$file")) {
					if (!@copy("$from/$file", "$to/$file")) return false;
				}
			}
			elseif ($file != '.' && $file != '..' && is_dir("$from/$file")) {
				if (!file_exists("$to/$file")) {
					if (!@mkdir("$to/$file", 0777)) return false;
				}
				$this->copyTree("$from/$file", "$to/$file");
			}
		}
		return true;
	}
	
	public function getSize($file) {
		return ;
	}
	
	public function delete() {
		$file = $this->absolute_path.($this->file != null ? '/'.$this->file : '');
		if (!file_exists($file)) {
			$this->error = sprintf("<b>%s</b> not exists", $this->file);
			return false;
		}
		
		if (is_file($file)) {
			return $this->deleteFile();
		}
		elseif (is_dir($file)) {
			return $this->deleteFolder($file);
		}
	}
	
	public function deleteFile() {
		if (!unlink($this->absolute_path.'/'.$this->file)) {
			$this->error = sprintf("Unable to delete <b>%s</b>", $this->file);
			return false;
		}
	}
	
	public function deleteFolder($dir_name) {
		@$dir= opendir("$dir_name");
		if (!$dir) {
			$this->error = sprintf("<b>%s</b> not found", $dir_name);
			return false;
		}
		while ($file = readdir($dir)) {
			if ($file != '.' && $file != '..' && is_dir("$dir_name/$file")) {
				$this->deleteFolder("$dir_name/$file");
			}
			else if ($file != '.' && $file != '..' && is_file("$dir_name/$file")) {
				@chmod("$dir_name/$file", 0644);
				if (!@unlink ("$dir_name/$file")) return false;
			}
		}
		closedir($dir);
		@chmod($dir_name, 0755);
		if (!@rmdir("$dir_name")) return false;
		return true;
	}
}

/**
 * @version		0.9
 * @author      Carlos Souza
 * @copyright   Copyright (c) 2005 Carlos Souza <csouza@web-sense.net>
 * @package     PHPGettext
 * @license		MIT License (http://www.opensource.org/licenses/mit-license.php)
 * @link		http://phpgettext.web-sense.net
 * 
 */
class PHPGettext_Message {
	public $comments = array();
	public $is_fuzzy = false;
	public $msgid = '';
	public $msgid_plural = '';
	public $msgstr = '';
	
	function PHPGettext_Message($msgid = "", $msgid_plural = null) {
		$this->msgid = $msgid;
		$this->msgid_plural =  $msgid_plural;
	}
	
	function setmsgstr($msgstr) {
		$this->msgstr = $msgstr;
		if (is_array($msgstr) && count($msgstr) == 1) $this->msgstr = $msgstr[0];
	}
	
	function setfuzzy($is_fuzzy = true) {
		$this->is_fuzzy = ($is_fuzzy) ? true : false;
	}
	
	function setcomments($comments) {
		if (is_array($comments)) return $this->comments = $comments;
		return false;
	}
	
	function toString() {
		$string = '';
		// comments
		if (count($this->comments > 0)) {
			foreach ($this->comments as $comment){
				if (strncmp($comment, "#:", 2) == 0) {
					$string .= trim($comment)."\n";
				} else {
					continue;
				}
			}
		}
		
		// fuzzy entries
		if ($this->is_fuzzy) {
			$string .= "#, fuzzy\n";
		}
		
		// msgid
		if (strpos($this->msgid, "\n") > 0) {
			if ($this->is_fuzzy) $string .= "#~ ";
			$string .= "msgid \"\"\n";
			$msgid = explode("\n", $this->msgid);
			foreach ($msgid as $line)
				$string .= "\"$line\\n\"\n";
		} else {
			if ($this->is_fuzzy) $string .= "#~ ";
			$string .= "msgid \"$this->msgid\"\n";
		}
		
		if (!empty($this->msgid_plural)) {
			$string .= "msgid_plural \"$this->msgid_plural\"\n";    
		} 
		
		// msgstr
		if (!is_array($this->msgstr) && strpos($this->msgstr, "\n") > 0) {
			if ($this->is_fuzzy) $string .= "#~ ";
			$string .= "msgstr \"\"\n";
			$msgstr = explode("\n", $this->msgstr);
			foreach ($msgstr as $line)
				$string .= "\"$line\\n\"\n";
		}  // plurals
		elseif (is_array($this->msgstr)) {
			foreach ($this->msgstr as $k => $msgstr) {
				if ($this->is_fuzzy) $string .= "#~ ";
				$string .= "msgstr[$k] \"$msgstr\"\n\n";
			}
		} else {
			if ($this->is_fuzzy) $string .= "#~ ";
			$string .= "msgstr \"$this->msgstr\"\n\n";
		}
		return $string;
	}
}

/**
 * Functions setComments, setHeaders, readPO, writePO Are From PHPGettext project (Copyright (c) 2005 Carlos Souza <csouza@web-sense.net>) with MIT License AND Modified by Apple Team.
 * Thank you Carlos for your beautiful code :)
 *
 */
class AppleGetText {
	
	public $path;
	public $file;
	public $comments = array();
	public $headers = array();
	public $strings = array();
	
	public function setComments($comments) {
		$comments = trim($comments);
		if (is_string($comments)) {
			$comments = explode("\n", $comments);
			if (is_array($comments)) {
				foreach ($comments as $comment) {
					if (strpos($comment, '#') == 1) {
						$this->comments .= $comment."\n";
					}
				}
			}
		}
	}
	
	public function setHeaders($headers) {
		if (!is_array($headers)) {
			return false;
		}
		foreach ($headers as $key => $value) {
			$this->headers[$key] = $value;
		}
	}
	
	public function readPO() {
		$file = $this->path.'/'.$this->file.'.po';
		if (!is_readable($file)) {
			return false;
		}
		
		// load file
		if (!$data = @file($file)) {
			return false;
		}
		
		$count      = 0;
		$comments   = '';
		$is_fuzzy   = false;
		$nplural    = false;
		
		// get all strings
		foreach ($data as $line) {
			// comments
			if (strncmp($line, "#", 1) == 0) {
				if ($count < 1) {
					$this->comments[] = $line;
				} else {
					if (strncmp($line, "#,", 2) == 0 && preg_match('/fuzzy/', $line)) {
						unset($line);
						$is_fuzzy = true;
					}
					if (strncmp($line, "#~ ", 3) == 0) {
						$line = preg_replace('/^(#~ )/', '', $line);
					}
					
					if (strncmp($line, "#:", 2) == 0 && !$is_fuzzy) {
						$comments[] = $line;
					}
				}
			}
			// msgid
			if (preg_match('/^msgid\s*"(.*)"\s*|^msgid_plural\s*"(.*)"\s*/s', $line, $matches)) {
				if (preg_match('/^msgid_plural\s*/s', $line, $arr)) {
					$nplural = true;
					$strings[$count]['msgid_plural'] = $matches[2];
				} else {
					$count++;
					$strings[$count]['comments'] = isset($comments) ? $comments : '';
					$strings[$count]['msgid']    = '';
					$strings[$count]['msgid_plural']    = '';
					$strings[$count]['msgstr']   = '';
					$strings[$count]['is_fuzzy'] = $is_fuzzy;
					if (!empty($matches[1])) {
						$strings[$count]['msgid'] = $matches[1];
					}
					unset($msgstr);
					unset($comments);
					$nplural  = false;
					$is_fuzzy = false;
				}
			}
			// msgstr
			elseif (preg_match('/^msgstr\s*"(.*)"\s*|^msgstr\[[0-9]\]\s*"(.*)"\s*/s', $line, $matches)) {
				$msgstr = true;
				if ($nplural) {
					$strings[$count]['msgstr'][] = isset($matches[2]) ? $matches[2] : '';
				} else {
					$strings[$count]['msgstr'] = $matches[1];
				}
			}
			// multiline msgid or msgstr
			elseif (preg_match('/^"(.*)"\s*$/s', $line, $matches)) {
				// headers
				if (isset($msgstr) && $count == 1) {
					list($key, $value) = explode(':', $matches[1], 2);
					$this->headers[$key] = $value;
				}
				elseif (isset($msgstr) && $count > 1) {
					$strings[$count]['msgstr'] .= $matches[1];
				}
				else { // msgid
					$strings[$count]['msgid']  .= $matches[1];
				}
			}
		}
		
		// load the strings
		array_shift($strings);
		for ($a=0; $a < count($strings); $a++) {
			$this->strings[$a] = new PHPGettext_Message($strings[$a]['msgid'], $strings[$a]['msgid_plural']);
			$this->strings[$a]->setmsgstr($strings[$a]['msgstr']);
			$this->strings[$a]->setfuzzy($strings[$a]['is_fuzzy']);
			$this->strings[$a]->setcomments($strings[$a]['comments']);
		}
		return true;
	}
	
	public function writePO() {
		$file = $this->path.'/'.$this->file.'.po';
		
		// open PO file
		if (!is_resource($res = @fopen($file, 'w'))) {
			trigger_error("Cannot create '$file'. ", E_USER_WARNING);
		}
		// lock PO file exclusively
		if (!@flock($res, LOCK_EX)) {
			@fclose($res);
			trigger_error("Cannot lock '$file'. ", E_USER_WARNING);
		}
		// write comments
		if (count($this->comments > 0)) {
			foreach ($this->comments as $line) {
				fwrite($res, trim($line)."\n");
			}
		}
		// write meta info
		if (count($this->headers > 0)) {
			$header = 'msgid ""' . "\nmsgstr " . '""' . "\n";
			foreach ($this->headers as $k => $v) {
				if (!strstr($v, '\n')) $v .= '\n';
				$header .= '"'.trim($k).': '.trim($v).'"'."\n";
			}
			fwrite($res, $header . "\n");
		}
		
		// write strings
		if (count($this->strings > 0)) {
			foreach ($this->strings as $string) {
				fwrite($res, $string->toString());
			}
		}
		//done
		@flock($res, LOCK_UN);
		@fclose($res);
		return true;
	}
}

class AppleCaptcha {
	public function render($url) {
		return '<img id="img_captcha" src="'.appleMakeSef($url).'" /> <a href="javascript:void(0)" onclick="playCaptcha(\''.$url.'\')"><img src="images/accessibility.png" alt="Accessibility" title="Accessibility" /></a>';
	}
}

class AppleMessage {
	protected $success;
	protected $warning;
	protected $error;
	protected $info;
	static private $instance = null;
	
	private function __construct() {
		foreach (get_object_vars($this) as $k=>$v) {
			$this->$k = &$_SESSION['Apple_Message_'.$k];
			if (!isset($_SESSION['Apple_Message_'.$k])) $this->$k = array();
		}
	}
	
	static public function getInstance() {
		if (self::$instance == null) self::$instance = new AppleMessage();
		return self::$instance;
	}
	
	public function add($type, $message) {
		if ($type == null || $message == null) return ;
		array_push($this->$type, $message);
	}
	
	public function get($type) {
		return $this->$type;
	}
	
	public function getAll() {
		$return = null;
		
		if (!empty($this->error)) $return .= '<div class="error"><b>'.__('ERROR').' : </b>'.implode('<br />', $this->error).'</div>';
		if (!empty($this->success)) $return .= '<div class="success">'.implode('<br />', $this->success).'</div>';
		if (!empty($this->warning)) $return .= '<div class="warning">'.implode('<br />', $this->warning).'</div>';
		if (!empty($this->info)) $return .= '<div class="info">'.implode('<br />', $this->info).'</div>';
		
		$this->destroy();
		return $return;
	}
	
	private function destroy() {
		unset($_SESSION['Apple_Message_success']);
		foreach (get_object_vars($this) as $k=>$v) {
			unset($_SESSION['Apple_Message_'.$k]);
		}
	}
	
	public function isNull() {
		return empty($this->success) && empty($this->warning) && empty($this->error) && empty($this->info);
	}
}
?>